package ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.logic;

import org.tandemframework.core.CoreStringUtils;
import org.tandemframework.core.exception.ApplicationException;
import org.tandemframework.hibsupport.DataAccessServices;
import org.tandemframework.hibsupport.dql.DQLExpressions;
import org.tandemframework.hibsupport.dql.DQLFunctions;
import org.tandemframework.hibsupport.dql.DQLSelectBuilder;
import org.tandemframework.shared.commonbase.base.bo.Common.CommonManager;
import org.tandemframework.shared.commonbase.base.entity.DatabaseFile;
import org.tandemframework.shared.commonbase.dao.SharedBaseDao;
import org.tandemframework.shared.commonbase.remoteDocument.bo.RemoteDocument.RemoteDocumentManager;
import org.tandemframework.shared.commonbase.remoteDocument.bo.RemoteDocument.logic.RemoteDocumentMeta;
import org.tandemframework.shared.commonbase.utils.ooffice.OpenOfficeServiceUtil;
import org.tandemframework.shared.person.catalog.entity.MilitaryOffice;
import ru.tandemservice.uni.entity.catalog.UniScriptItem;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.MilitaryDocumentManager;
import ru.tandemservice.uniclient.unimirea_code.clientUtils.ClientRemoteFileTypes;
import ru.tandemservice.uniclient.unimirea_code.entity.ClientRemoteFile;
import ru.tandemservice.uniclient.unimirea_code.entity.MilitaryDocument;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Arrays;
import java.util.Date;
import java.util.Map;

import static org.tandemframework.hibsupport.dql.DQLExpressions.*;

/**
 * Created by 22 on 14.12.2018.
 */
public class MilitaryDocumentDAO extends SharedBaseDao implements IMilitaryDocumentDAO {
    int maxNumber;

    public MilitaryDocumentDAO() {
    }

    public int createNumber(int prefix, int index) {
      /*DQLSelectBuilder  builder = new DQLSelectBuilder()
              .fromEntity(MilitaryDocument.class, "c")
              .top(1)
              .where(eq(property(MilitaryDocument.prefix().fromAlias("c")), value(prefix)))
              .column(property(MilitaryDocument.number().fromAlias("c")))
              .order(property(MilitaryDocument.number().fromAlias("c")), OrderDirection.desc);
      Number number = (Number) builder.createStatement(getSession()).uniqueResult();*/
        Number number = new DQLSelectBuilder().fromEntity(MilitaryDocument.class, "md")
                .where(eq(property(MilitaryDocument.prefix().fromAlias("md")), value(prefix)))
                .where(eq(property(MilitaryDocument.militaryDocumentType().index().fromAlias("md")), value(index)))
                .column(DQLFunctions.max(DQLExpressions.property(MilitaryDocument.number().fromAlias("md"))))
                .createStatement(getSession()).uniqueResult();
        int maxNumber = number == null ? 0 : number.intValue();
        return maxNumber + 1;
    }

    public void createPrintDocument(BaseModel baseModel) {
        DatabaseFile databaseFile = new DatabaseFile();
        byte[] document = new byte[0];
        final UniScriptItem script = baseModel.getMilitaryDocumentType().getScriptItem();
        int docIndex = baseModel.getMilitaryDocumentType().getIndex();
        switch (docIndex) {
            case 1:   //
                if (baseModel instanceof ModelAddMd1) {
                    ModelAddMd1 _model = (ModelAddMd1) baseModel;
                    final Map<String, Object> scriptResult = CommonManager.instance().scriptDao().getScriptResult(script, _model);
                    document = (byte[]) scriptResult.get("document");
                }
                break;
            case 2:
                if (baseModel instanceof ModelAddMd2) {
                    ModelAddMd2 _model = (ModelAddMd2) baseModel;
                    final Map<String, Object> scriptResult = CommonManager.instance().scriptDao().getScriptResult(script, _model);
                    document = (byte[]) scriptResult.get("document");
                }
                break;
            case 3:
                if (baseModel instanceof ModelAddMd3) {
                    ModelAddMd3 _model = (ModelAddMd3) baseModel;
                    final Map<String, Object> scriptResult = CommonManager.instance().scriptDao().getScriptResult(script, _model);
                    document = (byte[]) scriptResult.get("document");
                }
                break;
            case 4:   //
                if (baseModel instanceof ModelAddMd4) {
                    ModelAddMd4 _model = (ModelAddMd4) baseModel;
                    final Map<String, Object> scriptResult = CommonManager.instance().scriptDao().getScriptResult(script, _model);
                    document = (byte[]) scriptResult.get("document");
                }
                break;
            default: {
                throw new ApplicationException("Этот вид документа не обрабатывается. Обратитесь к разработчикам.");
            }
        }

        databaseFile.setContent(document);
        MilitaryDocumentManager.instance().dao().save(databaseFile);
        // create militaryDocument
        createMilitaryDocument(baseModel, databaseFile);
    }


    public void createMilitaryDocument(BaseModel model, DatabaseFile DbFile) {
        MilitaryDocument militaryDocument = new MilitaryDocument();
        militaryDocument.setFormingDate(new Date());
        militaryDocument.setNumber(model.getNumber());
        militaryDocument.setPrefix(model.getPrefix());
        militaryDocument.setPostfix(model.getPostfix());
        militaryDocument.setStudent(model.getStudent());
        militaryDocument.setMilitaryDocumentType(model.getMilitaryDocumentType());
        militaryDocument.setMilitaryOffice(model.getMilitaryOfficeTitle());
        militaryDocument.setExecutor(model.getContext().getFio());
        militaryDocument.setContent(DbFile);

        String baseFileName = getMilitaryDocumentFileName(militaryDocument, model.getMilitaryOffice());
        militaryDocument.setRtfFileName(baseFileName + ".rtf");

        saveOrUpdate(militaryDocument);

        // Создание Pdf версии справки П2П3, Пр9, П32П2
        if (Arrays.asList(1, 2, 4).contains(model.getMilitaryDocumentType().getIndex())) {
            try {
                ClientRemoteFile clientRemoteFile = new ClientRemoteFile();
                clientRemoteFile.setEntityId(militaryDocument.getId());
                switch (model.getMilitaryDocumentType().getIndex()) {
                    case 1: {
                        clientRemoteFile.setType(ClientRemoteFileTypes.P2P3.toString());
                        break;
                    }
                    case 2: {
                        clientRemoteFile.setType(ClientRemoteFileTypes.PR9.toString());
                        break;
                    }
                    case 4: {
                        clientRemoteFile.setType(ClientRemoteFileTypes.P32P2.toString());
                        break;
                    }
                }

                DataAccessServices.dao().saveOrUpdate(clientRemoteFile);

                String fileName = baseFileName + ".pdf";
//                String typeName = militaryDocument.getMilitaryDocumentType().getTitle();
//                String fileName = typeName + "_" + model.getStudent().getFio() + ".pdf";
//                String fileName = typeName + "_" + model.getStudent().getFio() + ".rtf";

                final ByteArrayOutputStream baos = new ByteArrayOutputStream();
                OpenOfficeServiceUtil.convertRtfToPdf(new ByteArrayInputStream(DbFile.getContent()), baos);

                RemoteDocumentMeta meta = clientRemoteFile.getRemoteMeta().setDefaultFileContent(CoreStringUtils.transliterate(fileName), baos.toByteArray());
//                RemoteDocumentMeta meta = clientRemoteFile.getRemoteMeta().setDefaultFileContent(CoreStringUtils.transliterate(fileName), DbFile.getContent());
                RemoteDocumentManager.instance().utilDao().createOrUpdateDefaultRemoteDocumentWithOwnerUpdate(meta);

                baos.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

    }

    /**
     * Метод возвращает название справки по военному учету без расширения (.rtf|.pdf)
     *
     * @param militaryDocument Справка
     * @param militaryOffice   Военкомат
     * @return возвращает название справок по военному учету без расширения (.rtf|.pdf)
     */
    public String getMilitaryDocumentFileName(MilitaryDocument militaryDocument, MilitaryOffice militaryOffice) {
        StringBuilder sb = new StringBuilder();

        if (militaryDocument.getMilitaryDocumentType().getIndex() == 2) {
            sb
                    .append("Сведения Пр9")
                    .append("_")
                    .append(militaryDocument.getStudent().getFio())
                    .append(" ");

            if (militaryOffice.getSettlement().getFullTitle().equals("г. Москва") || militaryOffice.getSettlement().getFullTitle().equals("обл. Московская")) {
                String[] words = militaryOffice.getTitle().split("\\s");
                for (int i = 0; i < words.length; i++) {
                    if (words[i].equals("города") && i != 0) {
                        break;
                    }
                    if (words[i].equals("Московской")) {
                        break;
                    }
                    sb.append(words[i]).append(" ");
                }

            } else {
                sb.append(militaryOffice.getSettlement().getFullTitle());
            }
        } else {
            sb
                    .append(militaryDocument.getMilitaryDocumentType().getTitle())
                    .append("_")
                    .append(militaryDocument.getStudent().getFio());
        }

        return sb.toString();
    }

}

//  //      IPrincipalContext context = UserContext.getInstance().getPrincipalContext();