package ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.ui.Add;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.tandemframework.caf.logic.ExecutionContext;
import org.tandemframework.caf.logic.handler.DefaultComboDataSourceHandler;
import org.tandemframework.caf.logic.handler.IDefaultComboDataSourceHandler;
import org.tandemframework.caf.ui.config.BusinessComponentManager;
import org.tandemframework.caf.ui.config.presenter.PresenterExtPoint;
import org.tandemframework.hibsupport.dql.DQLSelectBuilder;
import org.tandemframework.shared.commonbase.base.util.ui.EntityComboDataSourceHandler;
import org.tandemframework.shared.employeebase.base.entity.EmployeePost;
import org.tandemframework.shared.employeebase.catalog.entity.Post;
import ru.tandemservice.uniclient.unimirea_code.clientUtils.mireaIdConstants;
import ru.tandemservice.uniclient.unimirea_code.entity.catalog.MilitaryDocumentType;

import java.util.Arrays;
import java.util.List;

import static org.tandemframework.hibsupport.dql.DQLExpressions.*;

/**
 * Created by 22 on 10.12.2018.
 */
@Configuration
public class MilitaryDocumentAdd extends BusinessComponentManager {
    public static final String DOCUMENT_DS = "militaryDocumentDS";
    public static final String EMPLOYEE_DS = "employeeDS";

    @Override
    @Bean
    public PresenterExtPoint presenterExtPoint() {
        return presenterExtPointBuilder()
                .addDataSource(selectDS(DOCUMENT_DS, militaryDocumentDSHandler())
                        .addColumn(MilitaryDocumentType.title().s()))
                .addDataSource(selectDS(EMPLOYEE_DS, employeeDSHandler())
                        .addColumn(EmployeePost.person().fullFio().s())
                        .addColumn(EmployeePost.postRelation().postBoundedWithQGandQL().title().s()))
                .create();
    }

    @Bean
    public IDefaultComboDataSourceHandler militaryDocumentDSHandler() {
        return new DefaultComboDataSourceHandler(getName(), MilitaryDocumentType.class, MilitaryDocumentType.title());
    }

    @Bean
    public IDefaultComboDataSourceHandler employeeDSHandler() {
        return new EntityComboDataSourceHandler(getName(), EmployeePost.class) {
            @Override
            protected void applyWhereConditions(String alias, DQLSelectBuilder dql, ExecutionContext context) {
                super.applyWhereConditions(alias, dql, context);

                /*dql.where(eq(property(EmployeePost.orgUnit().id().fromAlias(alias)), value(mireaIdConstants.MILITAEY_DEPARTAMENT_ID)));
                dql.where(eq(property(EmployeePost.postStatus().active().fromAlias(alias)), value(Boolean.TRUE)));
                dql.where(eq(property(EmployeePost.postRelation().headerPost().fromAlias(alias)), value(Boolean.TRUE)));
            }
        }*/
                String docIndex = context.get("docIndex");
                List<Post> postList = context.get("postList");
                dql.where(eq(property(EmployeePost.postStatus().active().fromAlias(alias)), value(Boolean.TRUE)));

//                if (("2 3").contains(docIndex)) {
                if (("3").contains(docIndex)) {
                    dql.where(eq(property(EmployeePost.orgUnit().id().fromAlias(alias)), value(mireaIdConstants.MILITAEY_DEPARTAMENT_ID)));
                    dql.where(eq(property(EmployeePost.postRelation().headerPost().fromAlias(alias)), value(Boolean.TRUE)));
                }
                //         -----------------   П2П3
                if (docIndex.equals("1") || docIndex.equals("4")) {
                    dql.where(in(property(EmployeePost.postRelation().postBoundedWithQGandQL().post().fromAlias(alias)), postList));
                    dql.where(or(eq(property(EmployeePost.orgUnit().orgUnitType().title().fromAlias(alias)), value("Ректорат")),
                            or(eq(property(EmployeePost.orgUnit().orgUnitType().code().fromAlias(alias)), value("top")))));
                }
                //  Пр9
                if (docIndex.equals("2")) {
                    dql.where(eq(property(EmployeePost.orgUnit().id().fromAlias(alias)), value(mireaIdConstants.MILITAEY_DEPARTAMENT_ID)));
                    dql.where(eq(property(EmployeePost.postRelation().postBoundedWithQGandQL().code().fromAlias(alias)), value("25")));
                    dql.where(in(property(EmployeePost.person().identityCard().lastName().fromAlias(alias)), Arrays.asList("Борисенко", "Телицына", "Иванова")));
                }
            }
        }
                .order(EmployeePost.person().identityCard().fullFio())
                .pageable(true);
    }
}


