package ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.ui.Add;

import org.tandemframework.caf.ui.UIPresenter;
import org.tandemframework.caf.ui.datasource.IUIDataSource;
import org.tandemframework.core.component.Bind;
import org.tandemframework.core.component.Input;
import org.tandemframework.hibsupport.DataAccessServices;
import org.tandemframework.hibsupport.dql.DQLSelectBuilder;
import org.tandemframework.shared.employeebase.base.entity.EmployeePost;
import org.tandemframework.shared.employeebase.base.entity.OrgUnitTypePostRelation;
import org.tandemframework.shared.employeebase.catalog.entity.Post;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.logic.BaseModel;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.logic.BaseModel;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.util.MilitaryDocumentAddBaseUI;
import ru.tandemservice.uniclient.unimirea_code.entity.catalog.MilitaryDocumentType;

import java.util.Arrays;
import java.util.List;

import static org.tandemframework.hibsupport.dql.DQLExpressions.eq;
import static org.tandemframework.hibsupport.dql.DQLExpressions.property;
import static org.tandemframework.hibsupport.dql.DQLExpressions.value;

/**
 * Created by 22 on 10.12.2018.
 */
@Input({
        @Bind(key = "studentId", binding = "studentId")})
public class MilitaryDocumentAddUI extends UIPresenter {
  String COMPONENT_GO;
    private MilitaryDocumentType _documentType;
    private Long _studentId;
    public static final String BIND_PERSON = "studentId";
    private EmployeePost _employeePost;
    private boolean _postDisabled;
    private boolean _postYes;

    public Long getStudentId() {
        return _studentId;
    }
    public void setStudentId(Long studentId) {
        _studentId = studentId;
    }
    public MilitaryDocumentType getDocumentType() {
        return _documentType;
    }
    public void setDocumentType(MilitaryDocumentType documentType) {
        _documentType = documentType;
    }
    public EmployeePost getEmployeePost() {
        return _employeePost;
    }
    public void setEmployeePost(EmployeePost employeePost) {
        _employeePost = employeePost;  }
//    public void setPostDisabled(boolean postDisabled)  {_postDisabled = postDisabled;}
    public boolean isPostDisabled() {return !_postYes;}
    public void setPostYes(boolean postYes)  {_postYes = postYes;}
    public boolean isPostYes() {return _postYes;}

    public void onComponentActivate() {       setPostYes(false);    }

    public void onChangeMilitaryDocumentType() {

        MilitaryDocumentType docType = getDocumentType();
        getConfig().deactivateComponent();
        String stringIndex = String.valueOf(docType.getIndex());
        COMPONENT_GO =  "MilitaryDocumentAddMd" + stringIndex;

//        String stop ="stop";
        getActivationBuilder().asRegionDialog(COMPONENT_GO)
                .parameter("studentId", _studentId)
                .parameter(MilitaryDocumentAddBaseUI.DOCUMENT_TYPE, _documentType)
                .parameter(MilitaryDocumentAddBaseUI.EMPLOYEE_POST, _employeePost)
                .activate();
    }
    public void onChooseDocument() {
        String post = "1 2 3 4";      // строка индексов для которых нужно выбирать руководителя или зама подрзделения из меню
        // 1 - ректорат; 2-3 УМП
        String stringIndex = String.valueOf(getDocumentType().getIndex());
        setPostYes(post.contains(stringIndex));
    }
    @Override
    public void onBeforeDataSourceFetch(IUIDataSource dataSource) {
        DQLSelectBuilder query = new DQLSelectBuilder().fromEntity(OrgUnitTypePostRelation.class,  "pr")
                .column(property("pr", OrgUnitTypePostRelation.postBoundedWithQGandQL().post()))
                .where(eq(property(OrgUnitTypePostRelation.headerPost().fromAlias("pr")), value(Boolean.TRUE)))
                .where(eq(property(OrgUnitTypePostRelation.orgUnitType().title().fromAlias("pr")), value("Ректорат")));
        List<Post> postList = DataAccessServices.dao().getList(query);

        if (dataSource.getName().equals("employeeDS")) {
            dataSource.put("docIndex", String.valueOf(getDocumentType().getIndex()));
            dataSource.put("postList", postList);
        }
    }
}

/*
getActivationBuilder().asRegionDialog(AdminNewEdit.class.getSimpleName()).activate();
 */