package ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.ui.AddMd1;

import org.tandemframework.core.entity.IdentifiableWrapper;
import org.tandemframework.core.entity.OrderDirection;
import org.tandemframework.hibsupport.DataAccessServices;
import org.tandemframework.hibsupport.dql.DQLExpressions;
import org.tandemframework.hibsupport.dql.DQLFunctions;
import org.tandemframework.hibsupport.dql.DQLSelectBuilder;
import org.tandemframework.shared.commonbase.base.bo.Declinable.logic.GrammaCase;
import org.tandemframework.shared.commonbase.base.util.CommonBaseDateUtil;
import org.tandemframework.shared.person.base.bo.PersonEduDocument.PersonEduDocumentManager;
import org.tandemframework.shared.person.base.entity.PersonMilitaryStatus;
import org.tandemframework.shared.person.catalog.entity.MilitaryOffice;
import ru.tandemservice.movestudent.entity.ListStudentExtract;
import ru.tandemservice.uni.entity.base.Student;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.MilitaryDocumentManager;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.logic.BaseModel;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.logic.ModelAddMd1;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.util.MilitaryDocumentAddBaseUI;
import ru.tandemservice.uniclient.unimirea_code.clientUtils.UnimireaProjectUtils;

import static org.tandemframework.hibsupport.dql.DQLExpressions.*;

import java.util.*;

/**
 * Created by 22 on 12.12.2018.
 */
public class MilitaryDocumentAddMd1UI extends MilitaryDocumentAddBaseUI {
    private ModelAddMd1 _model;

    @Override
    public void onComponentActivate() {
        super.onComponentActivate();

        if (null == _model) _model = new ModelAddMd1();
          _model.setYearOut(0);
        // --- копируем данные BaseModel
            BaseModel baseModel = getBaseModel();
        _model.setStudent(baseModel.getStudent());
        _model.setFormingDate(baseModel.getFormingDate());
        //_model.setExecutor(baseModel.getExecutor());
        _model.setContext(baseModel.getContext());
        _model.setCurrentYear(baseModel.getCurrentYear());
        _model.setMilitaryDocumentType(baseModel.getMilitaryDocumentType());
        _model.setMilitaryOfficeTitle(baseModel.getMilitaryOfficeTitle());
        _model.setPrefix(baseModel.getPrefix());
        _model.setEnrollmentOrderDate(baseModel.getEnrollmentOrderDate());
        _model.setEnrollmentOrderNumber(baseModel.getEnrollmentOrderNumber());
        _model.setEntranceYear(baseModel.getEntranceYear());
        _model.setEntranceYear( _model.getStudent().getEntranceYear());
        _model.setEmployeePost(baseModel.getEmployeePost());

        // --- даты, месяцы
/*        Calendar currentYear = Calendar.getInstance();
        _model.setCurrentYear(currentYear.get(Calendar.YEAR)); */
        List<IdentifiableWrapper> monthList = new ArrayList<>(12);
        for (int i = 1; i <= 12; i++)
            monthList.add(new IdentifiableWrapper((long) i, CommonBaseDateUtil.getMonthNameDeclined(i, GrammaCase.NOMINATIVE)));
        _model.setMonthList(monthList);

        studentData();
    }
    @Override
    public void onComponentRefresh() {

        if (!_model.isTrainingOfficersActive())
        {
            _model.setProgramStartYear(null);
            _model.setMonth(null);
            _model.setProgramEndYear(null);
            _model.setManagerMilitaryDepartment(null);
            _model.setMonthStart(null);
            _model.setOutOrderDate(null);
            _model.setOutOrderNumber(null);
            _model.setReasonOut(null);
            _model.setReserv(null);
            _model.setMilitaryOfficeAtt(null);
            _model.setOfficeRegion(null);
        }
    }

    private void studentData() {
        Student student = _model.getStudent();
        _model.setCourse( student.getCourse());
        Calendar calendar = Calendar.getInstance();
        _model.setEducationLevelStageHint("Сведения об образовании призывника до поступления в данное образовательное учреждение заполняются только образовательными учреждениями среднего профессионального образования и начального профессионального образования.");        // продолжительность программы обучения
        _model.setYearOut(UnimireaProjectUtils.getFinishYear(student.getId()));

        String sprav = "в соответствии с пунктом 2 статьи 8 ФЗ от 28 марта 1998 г. № 53-ФЗ «О воинской обязанности и военной службе»";
        MilitaryOffice _office = (DataAccessServices.dao().get(PersonMilitaryStatus.class, PersonMilitaryStatus.L_PERSON, student.getPerson())).getMilitaryOffice();
        String _region = _office.getSettlement().getInheritedRegionCode();
        _model.setOfficeRegion(_region);
        int cour = student.getCourse().getIntValue();
        if(cour==1){
            if((!_region.equals("50")) &&(!_region.equals("77"))){
                _model.setMilitaryOfficeTitle(sprav);
            }
        }

        _model.setEducationLevelStage(PersonEduDocumentManager.instance().dao().getHighestEduLevel(student.getPerson().getId()));
    }

    public ModelAddMd1 getModel()
    {
        return _model;
    }
    public void setModel(ModelAddMd1 model)
    {
        _model = model;
    }

    public void onClickApply() {
        _model.setPostfix(_model.getCourse().getTitle());
        _model.setPrefix(_model.getCurrentYear().intValue());
        _model.setNumber(MilitaryDocumentManager.instance().dao().createNumber(_model.getPrefix(), _model.getMilitaryDocumentType().getIndex()));
        //
        _model.setDocNumber(fullNumber((BaseModel) _model));
        String ddd = _model.getMilitaryOfficeAtt();
        MilitaryDocumentManager.instance().dao().createPrintDocument((BaseModel) _model);

        getConfig().deactivateComponent();
          }
}
