package ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.ui.AddMd3;

import org.tandemframework.hibsupport.DataAccessServices;
import org.tandemframework.hibsupport.dql.DQLSelectBuilder;
import org.tandemframework.shared.employeebase.base.entity.EmployeePost;
import ru.tandemservice.uni.entity.base.Student;
import ru.tandemservice.uni.entity.catalog.Course;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.MilitaryDocumentManager;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.logic.BaseModel;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.logic.ModelAddMd3;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.util.MilitaryDocumentAddBaseUI;
import ru.tandemservice.uniclient.unimirea_code.clientUtils.mireaIdConstants;

import java.util.List;

import static org.tandemframework.hibsupport.dql.DQLExpressions.eq;
import static org.tandemframework.hibsupport.dql.DQLExpressions.property;
import static org.tandemframework.hibsupport.dql.DQLExpressions.value;

public class MilitaryDocumentAddMd3UI extends MilitaryDocumentAddBaseUI {
    private ModelAddMd3 _model;

    @Override
    public void onComponentActivate() {
        super.onComponentActivate();
        if (null == _model) _model = new ModelAddMd3();
        // --- копируем данные BaseModel
        BaseModel baseModel = getBaseModel();
        _model.setStudent(baseModel.getStudent());
        _model.setFormingDate(baseModel.getFormingDate());
        //      _model.setExecutor(baseModel.getExecutor());
        _model.setContext(baseModel.getContext());
        _model.setCurrentYear(baseModel.getCurrentYear());
        _model.setEmployeePost(baseModel.getEmployeePost());
        _model.setMilitaryDocumentType(baseModel.getMilitaryDocumentType());
        _model.setMilitaryOfficeTitle(baseModel.getMilitaryOfficeTitle());
        _model.setPrefix(baseModel.getPrefix());
        _model.setEnrollmentOrderDate(baseModel.getEnrollmentOrderDate());
        _model.setEnrollmentOrderNumber(baseModel.getEnrollmentOrderNumber());
        _model.setEntranceYear(baseModel.getEntranceYear());
        _model.setEntranceYear( _model.getStudent().getEntranceYear());
        this.studentData();
    }
    private void studentData() {
        Student student = _model.getStudent();
        // поступил на 1 курс
        _model.setCourse(DataAccessServices.dao().get(Course.class, Course.intValue(), 1));
        List<EmployeePost> posts = DataAccessServices.dao().getList(new DQLSelectBuilder()
                .fromEntity(EmployeePost.class, "c")
                .column(property("c"))
                .where(eq(property(EmployeePost.orgUnit().id().fromAlias("c")),  value(mireaIdConstants.MILITAEY_DEPARTAMENT_ID)))
                .where(eq(property(EmployeePost.postStatus().active().fromAlias("c")), value(Boolean.TRUE)))
                .where(eq(property(EmployeePost.postRelation().headerPost().fromAlias("c")), value(Boolean.TRUE)))
                .order(property(EmployeePost.person().identityCard().fullFio().fromAlias("c"))));
        EmployeePost ep;
        if(posts.size()>0)
            ep = posts.get(0);
        String stop ="stop";
    }
    public ModelAddMd3 getModel()  { return _model;   }
    public void setModel(ModelAddMd3 model) { _model = model; }

    public void onClickApply() {
        _model.setPostfix("");
        if (_model.getCurrentYear() == null){
            String stop ="stop";}
        _model.setPrefix(_model.getCurrentYear().intValue());
        _model.setNumber(MilitaryDocumentManager.instance().dao().createNumber(_model.getPrefix(), _model.getMilitaryDocumentType().getIndex()));
        _model.setDocNumber(fullNumber((BaseModel) _model));
        MilitaryDocumentManager.instance().dao().createPrintDocument((BaseModel) _model);

        getConfig().deactivateComponent();
    }

}