package ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.ui.AddMd4;

import org.tandemframework.core.entity.IdentifiableWrapper;
import org.tandemframework.hibsupport.DataAccessServices;
import org.tandemframework.shared.commonbase.base.bo.Declinable.logic.GrammaCase;
import org.tandemframework.shared.commonbase.base.util.CommonBaseDateUtil;
import org.tandemframework.shared.person.base.bo.PersonEduDocument.PersonEduDocumentManager;
import org.tandemframework.shared.person.base.entity.PersonMilitaryStatus;
import org.tandemframework.shared.person.catalog.entity.MilitaryOffice;
import ru.tandemservice.uni.entity.base.Group;
import ru.tandemservice.uni.entity.base.Student;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.MilitaryDocumentManager;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.logic.BaseModel;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.logic.ModelAddMd4;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.util.MilitaryDocumentAddBaseUI;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

public class MilitaryDocumentAddMd4UI extends MilitaryDocumentAddBaseUI {
    private ModelAddMd4 _model;

    @Override
    public void onComponentActivate() {
        super.onComponentActivate();

        if (null == _model) _model = new ModelAddMd4();
        _model.setYearOut(null);
        // --- копируем данные BaseModel
        BaseModel baseModel = getBaseModel();
        _model.setStudent(baseModel.getStudent());
        _model.setFormingDate(baseModel.getFormingDate());
        //_model.setExecutor(baseModel.getExecutor());
        _model.setContext(baseModel.getContext());
        _model.setCurrentYear(baseModel.getCurrentYear());
        _model.setMilitaryDocumentType(baseModel.getMilitaryDocumentType());
        _model.setMilitaryOfficeTitle(baseModel.getMilitaryOfficeTitle());
        _model.setPrefix(baseModel.getPrefix());
        _model.setEnrollmentOrderDate(baseModel.getEnrollmentOrderDate());
        _model.setEnrollmentOrderNumber(baseModel.getEnrollmentOrderNumber());
        _model.setEntranceYear(baseModel.getEntranceYear());
        _model.setEntranceYear(_model.getStudent().getEntranceYear());
        _model.setEmployeePost(baseModel.getEmployeePost());

        // --- даты, месяцы
/*        Calendar currentYear = Calendar.getInstance();
        _model.setCurrentYear(currentYear.get(Calendar.YEAR)); */
        List<IdentifiableWrapper> monthList = new ArrayList<>(12);
        for (int i = 1; i <= 12; i++)
            monthList.add(new IdentifiableWrapper((long) i, CommonBaseDateUtil.getMonthNameDeclined(i, GrammaCase.NOMINATIVE)));
        _model.setMonthList(monthList);

        studentData();
    }

    @Override
    public void onComponentRefresh() {

        if (!_model.isTrainingOfficersActive()) {
            _model.setProgramStartYear(null);
            _model.setMonth(null);
            _model.setProgramEndYear(null);
            _model.setManagerMilitaryDepartment(null);
            _model.setMonthStart(null);
            _model.setOutOrderDate(null);
            _model.setOutOrderNumber(null);
            _model.setReasonOut(null);
            _model.setReserv(null);
            _model.setMilitaryOfficeAtt(null);
            _model.setOfficeRegion(null);
        }
    }

    private void studentData() {
        Student student = _model.getStudent();
        _model.setCourse(student.getCourse());
        Calendar calendar = Calendar.getInstance();
        _model.setEducationLevelStageHint("Сведения об образовании призывника до поступления в данное образовательное учреждение заполняются только образовательными учреждениями среднего профессионального образования и начального профессионального образования.");        // продолжительность программы обучения
        int endYear = 0;
        String endDate = null;
        int course = student.getCourse().getIntValue(); // текущий курс студента
        Group group = student.getGroup();
        int courseGroup = group.getCourse().getIntValue();
        String groupTitle = group.getTitle();
        int poi = groupTitle.indexOf("-", 6);
        int yearStart = 0;
        if (poi == -1) {
            yearStart = group.getStartEducationYear().getIntValue();
        } else {
            yearStart = Integer.valueOf("20" + groupTitle.substring(poi + 1, poi + 3));           // год группы
        }
        if (groupTitle == "РААО-01-19")            // номер группы и год начала не соответствуют году приема - это аспиранты
            yearStart = 2020;
        int programYears = 0;
        int programMonths = 0;
        boolean acad = student.getStatus().isUsedAsAcademicLeave();           // в академке
        if (student.getDevelopPeriodAuto() != null) {
            programYears = student.getDevelopPeriodAuto().getNumberOfYears();
            programMonths = student.getDevelopPeriodAuto().getNumberOfMonths();
            endYear = yearStart + programYears;
            if ((course < courseGroup) && acad) {        // в академке - группа у студента осталась, а курс у группы уже другой
                endYear = endYear + courseGroup - course;
            }
            if (programMonths > 4)
                endYear++;
            int gg = endYear;
            int currMonth = calendar.get(Calendar.MONTH);
            int currYear = calendar.get(Calendar.YEAR);
            //        if (endYear<=currYear && course==courseGroup)                                 // остались в старой группе, а вся группа уже закончила-академкка или после академки
            //            endYear=currYear+(currYear-endYear)+1;
            String formUnit = student.getEducationOrgUnit().getFormativeOrgUnit().getTitle();
            int monthStart = 9;
            String formCode = student.getEducationOrgUnit().getDevelopForm().getCode();
            if ((student.getEducationOrgUnit().getDevelopForm().getCode()).equals("2") || formUnit.contains("спирантур") || formUnit.contains("Ставропол") || (student.getEducationOrgUnit().getDevelopForm().getCode()).equals("3"))
                monthStart = 10;

            // заочная форма или аспиранты, или Ставрополь и очно-заочная форма
            int finishMonth = monthStart + (programMonths - 1) < 13 ? monthStart + (programMonths - 1) : monthStart + (programMonths - 1) - 12;
            Calendar c = Calendar.getInstance();
            c.set(Calendar.YEAR, endYear);
            c.set(Calendar.MONTH, finishMonth);
            c.set(Calendar.DAY_OF_MONTH, 1);
            c.add(Calendar.DAY_OF_MONTH, -1);
            int finishDay = c.get(Calendar.DAY_OF_MONTH);   // последний день месяца
            c.set(Calendar.MONTH, finishMonth - 1);
            c.set(Calendar.DAY_OF_MONTH, finishDay);
            DateFormat df = new SimpleDateFormat("dd.MM.yyyy");
            endDate = df.format(c.getTime());
        }
        _model.setYearOut(endDate);
        String sprav = "в соответствии с пунктом 2 статьи 8 ФЗ от 28 марта 1998 г. № 53-ФЗ «О воинской обязанности и военной службе»";
        MilitaryOffice _office = (DataAccessServices.dao().get(PersonMilitaryStatus.class, PersonMilitaryStatus.L_PERSON, student.getPerson())).getMilitaryOffice();
        String _region = _office.getSettlement().getInheritedRegionCode();
        _model.setOfficeRegion(_region);
        int cour = student.getCourse().getIntValue();
        if (cour == 1) {
            if ((!_region.equals("50")) && (!_region.equals("77"))) {
                _model.setMilitaryOfficeTitle(sprav);
            }
        }

        _model.setEducationLevelStage(PersonEduDocumentManager.instance().dao().getHighestEduLevel(student.getPerson().getId()));
    }

    public ModelAddMd4 getModel() {
        return _model;
    }

    public void setModel(ModelAddMd4 model) {
        _model = model;
    }

    public void onClickApply() {
        _model.setPostfix(_model.getCourse().getTitle());
        _model.setPrefix(_model.getCurrentYear().intValue());
        _model.setNumber(MilitaryDocumentManager.instance().dao().createNumber(_model.getPrefix(), _model.getMilitaryDocumentType().getIndex()));
        //
        _model.setDocNumber(fullNumber((BaseModel) _model));
        String ddd = _model.getMilitaryOfficeAtt();
        MilitaryDocumentManager.instance().dao().createPrintDocument((BaseModel) _model);

        getConfig().deactivateComponent();
    }
}
