package ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.util;

import org.tandemframework.caf.ui.UIPresenter;
import org.tandemframework.core.component.Bind;
import org.tandemframework.core.component.Input;
import org.tandemframework.core.context.UserContext;
import org.tandemframework.core.exception.ApplicationException;
import org.tandemframework.hibsupport.DataAccessServices;
import org.tandemframework.shared.employeebase.base.entity.EmployeePost;
import org.tandemframework.shared.person.base.entity.PersonMilitaryStatus;
import org.tandemframework.shared.person.catalog.entity.MilitaryOffice;
import ru.tandemservice.uni.entity.base.OrderData;
import ru.tandemservice.uni.entity.base.Student;
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.logic.BaseModel;
import ru.tandemservice.uniclient.unimirea_code.entity.catalog.MilitaryDocumentType;

import java.util.Calendar;
import java.util.Date;

/**
 * Created by 22 on 12.12.2018.
 */

@Input({
        @Bind(key = "studentId", binding = "studentId", required = true),
        @Bind(key = "militaryDocumentType", binding = "militaryDocumentType", required = true),
        @Bind(key = "employeePost", binding = "employeePost", required = false)
})
public class MilitaryDocumentAddBaseUI extends UIPresenter {
    public static final String DOCUMENT_TYPE = "militaryDocumentType";
    public static final String EMPLOYEE_POST = "employeePost";

    private BaseModel _model = new BaseModel();
    private Student _student = new Student();
    private Long _studentId;
    private MilitaryDocumentType _militaryDocumentType = new MilitaryDocumentType();
    private EmployeePost _employeePost = new EmployeePost();
    private int _militaryDocumentIndex = 0;

    @Override
    public void onComponentActivate() {
        setStudent(DataAccessServices.dao().get(Student.class, _studentId));
        Student student = getStudent();
        PersonMilitaryStatus miliStat = (DataAccessServices.dao().get(PersonMilitaryStatus.class, PersonMilitaryStatus.L_PERSON, student.getPerson()));
        if (miliStat == null) {
            throw new ApplicationException("Нет данных о воинском учете");
        }
        MilitaryOffice _office = (DataAccessServices.dao().get(PersonMilitaryStatus.class, PersonMilitaryStatus.L_PERSON, student.getPerson())).getMilitaryOffice();
   /*     if (null == _model) _model = new BaseModel();*/
        // данные из binding
        _model.setStudent(student);
        _model.setMilitaryDocumentType(getMilitaryDocumentType());
        MilitaryDocumentType type = getMilitaryDocumentType();
        //
        _model.setMilitaryOfficeTitle(_office.getTitle());
        _model.setMilitaryOffice(_office);
        Calendar calendar = Calendar.getInstance();
        _model.setFormingDate(new Date());
        _model.setEmployeePost(getEmployeePost());
        _model.setContext(UserContext.getInstance().getPrincipalContext());

        OrderData orderData = DataAccessServices.dao().get(OrderData.class, OrderData.L_STUDENT, student);
        Calendar currentYear = Calendar.getInstance();
        _model.setCurrentYear(currentYear.get(Calendar.YEAR));
        // Поступление - приказ о зачислении или восстановлении
        // entDate - проверить на null
        Date entDate = null;
        Date restDate = null;
        if (orderData != null) {
            entDate = orderData.getEduEnrollmentOrderDate();
            restDate = orderData.getRestorationOrderDate();
            if (restDate != null && entDate != null && restDate.after(entDate) || restDate != null && entDate == null) {
                _model.setEnrollmentOrderDate(restDate);
                _model.setEnrollmentOrderNumber(orderData.getRestorationOrderNumber());
                calendar.setTime(restDate); // Date date
                _model.setEntranceYear(calendar.get(Calendar.YEAR));
            } else {
                if (entDate != null) {
                    _model.setEnrollmentOrderDate(entDate);
                    _model.setEnrollmentOrderNumber(orderData.getEduEnrollmentOrderNumber());
                    _model.setEntranceYear(_model.getStudent().getEntranceYear());
                }
            }
        }
    }

    public String fullNumber(BaseModel model) {
        /* inline
        String fullNumber = (model.getNumber() != 0 ? String.valueOf(model.getNumber()) : "") +
                (model.getPostfix() == null || model.getPostfix().isEmpty() ? "" : "/" + model.getPostfix());

        return fullNumber;*/
        return (model.getNumber() != 0 ? String.valueOf(model.getNumber()) : "") +
                (model.getPostfix() == null || model.getPostfix().isEmpty() ? "" : "/" + model.getPostfix());
    }

    // Getters & Setters
    public Long getStudentId() {
        return _studentId;
    }
    public void setStudentId(Long studentId) {
        _studentId = studentId;
    }

    public Student getStudent() {
        return _student;
    }
    public void setStudent(Student student) {
        _student = student;
    }

    public MilitaryDocumentType getMilitaryDocumentType() {
        return _militaryDocumentType;
    }
    public void setMilitaryDocumentType(MilitaryDocumentType militaryDocumentType) {
        _militaryDocumentType = militaryDocumentType;
    }

    public EmployeePost getEmployeePost() {
        return _employeePost;
    }
    public void setEmployeePost(EmployeePost employeePost) {
        _employeePost = employeePost;
    }

    public BaseModel getBaseModel() {
        return _model;
    }
    public void setBaseModel(BaseModel model) {
        _model = model;
    }
}

