package ru.tandemservice.uniclient.unimirea_code.base.ext.Person.ui.Tab;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.tandemframework.caf.ui.config.BusinessComponentExtensionManager;
import org.tandemframework.caf.ui.config.presenter.PresenterExtension;
import org.tandemframework.caf.ui.config.tab.TabPanelExtension;
import org.tandemframework.shared.person.base.bo.Person.ui.Tab.PersonTab;
import ru.tandemservice.uniclient.unimirea_code.base.bo.ImoBusinessLetter.ui.List.ImoBusinessLetterList;

//import ru.tandemservice.unimirea.base.ext.MireaClientPerson.ui.Tab.PersonTabExtUI;

/**
 * Created by 22 on 20.07.2017.
 */
@Configuration
public class PersonTabExt extends BusinessComponentExtensionManager {
    public static final String ADDON_NAME = "unimirea_code" + PersonTabExtUI.class.getSimpleName();
    public static final String DOCUMENT_SEARCH_DS = "documentSearchDS";
    public static final String BUSINESS_LETTER_TAB ="businessLetterTab";

    @Autowired
    private PersonTab _personTab;

    @Bean
    public PresenterExtension presenterExtension() {
        return presenterExtensionBuilder(_personTab.presenterExtPoint())
                .addAddon(uiAddon(ADDON_NAME, PersonTabExtUI.class))
                .create();
    }

    @Bean
    public TabPanelExtension tabPanelExtension() {
        return tabPanelExtensionBuilder(_personTab.personTabPanelExtPoint())
                .addTab(componentTab(BUSINESS_LETTER_TAB, ImoBusinessLetterList.class)
                        .before(PersonTab.LOGIN_TAB)
                        .visible("addon:" + ADDON_NAME + ".letterTabVisible"))
                .create();
    }

}