package ru.tandemservice.uniclient.unimirea_code.entity;

import org.tandemframework.shared.commonbase.file.FileNotFoundApplicationException;
import org.tandemframework.shared.commonbase.remoteDocument.bo.RemoteDocument.RemoteDocumentManager;
import org.tandemframework.shared.commonbase.remoteDocument.bo.RemoteDocument.logic.RemoteDocumentMeta;
import org.tandemframework.shared.commonbase.remoteDocument.dto.RemoteDocumentDTO;
import org.tandemframework.shared.commonbase.remoteDocument.entity.InternalDBDocument;
import ru.tandemservice.uniclient.unimirea_code.entity.gen.*;
import ru.tandemservice.uniclient.unimirea_code.remoteDocument.ext.RemoteDocument.RemoteDocumentExtManager;

/**
 * @see ru.tandemservice.uniclient.unimirea_code.entity.gen.ClientRemoteFileGen
 */
public class ClientRemoteFile extends ClientRemoteFileGen {

    @Override
    public String getDefaultPath() {
        return ClientRemoteFile.L_DATA;
    }

    @Override
    public void setRemoteDocument(String property, InternalDBDocument document) {
        setData(document);
    }

    @Override
    public InternalDBDocument getRemoteDocument(String propertyPath) {
        return getData();
    }

    @Override
    public RemoteDocumentMeta getRemoteMeta() {
        RemoteDocumentMeta meta = new RemoteDocumentMeta(this);
        meta.setDocumentTitleForProperty(ClientRemoteFile.data().s(), createFileTitle());
        meta.setModuleName(RemoteDocumentExtManager.REMOTE_DOCUMENT_MODULE);
        meta.setServiceName(RemoteDocumentExtManager.MIREA_CLIENT_DOCS_SERVICE_NAME);
        return meta;
    }

    private String createFileTitle() {
        return "Документ " + getId() ;
    }

    public RemoteDocumentDTO getFileDto() {
        RemoteDocumentDTO dto;
        try {
            dto = RemoteDocumentManager.instance().utilDao().getRemoteDocumentDTO(this);
        } catch (FileNotFoundApplicationException ex) {
            ex.printStackTrace();
            return null;  //файла нет
        }
        return dto;
    }

}