package unimirea_code.scripts.students

import org.hibernate.Session
import org.tandemframework.core.entity.OrderDirection
import org.tandemframework.core.sec.IPrincipalContext
import org.tandemframework.core.view.formatter.DateFormatter
import org.tandemframework.hibsupport.dql.DQLExpressions
import org.tandemframework.hibsupport.dql.DQLSelectBuilder
import org.tandemframework.rtf.document.RtfDocument
import org.tandemframework.rtf.io.RtfReader
import org.tandemframework.rtf.modifiers.RtfInjectModifier
import org.tandemframework.rtf.modifiers.RtfTableModifier
import org.tandemframework.rtf.util.RtfUtil
import org.tandemframework.shared.employeebase.base.entity.EmployeePost
import org.tandemframework.shared.fias.base.entity.AddressBase
import org.tandemframework.shared.person.base.entity.Person
import org.tandemframework.shared.person.base.entity.PersonMilitaryStatus
import ru.tandemservice.movestudent.entity.ModularStudentExtract
import ru.tandemservice.uni.entity.base.OrderData
import ru.tandemservice.uni.entity.base.Student
import ru.tandemservice.uni.entity.catalog.EduProgramKind
import ru.tandemservice.uni.entity.catalog.EducationLevelsHighSchool
import ru.tandemservice.uni.entity.catalog.codes.EduProgramKindCodes
import ru.tandemservice.uni.entity.catalog.subjects.EduProgramSubject
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.logic.ModelAddMd3
import ru.tandemservice.unimirea.entity.MireaExcludeStuListExtract
import ru.tandemservice.unimirea.entity.MireaExcludeSuccessStuListExtract

import java.time.LocalDateTime

import static org.tandemframework.hibsupport.dql.DQLExpressions.*

return new FormApp2Print(                           // стандартные входные параметры скрипта
        session: session,
        template: template,
        model: object
).print();


class FormApp2Print {
    Session session
    byte[] template
    ModelAddMd3 model

    /*Student student = model.student;
    Person person = student.person;
    */
    def im = new RtfInjectModifier()
    def tm = new RtfTableModifier()
    def now = LocalDateTime.now()

    def print() {
        String userPhone = "";
        String userName = "";
        Student student = model.getStudent();
        Person person = student.person;
        EmployeePost post = model.getEmployeePost();
        IPrincipalContext context = model.getContext();
        String sprNumber = model.getDocNumber();
        String sprDate = model.getFormingDate() == null ? "___" : DateFormatter.DEFAULT_DATE_FORMATTER.format(model.getFormingDate())

        EducationLevelsHighSchool educationLevelHS = model.getStudent().getEducationOrgUnit().getEducationLevelHighSchool();
        EduProgramKind programKind = educationLevelHS.getEduProgramSubject().getEduProgramKind();
 //       EduProgramSubject programSubject = educationLevelHS.getEduProgramSubject();

        if (context instanceof EmployeePost) {
            EmployeePost userPost = (EmployeePost) context;
            userName = userPost.getPerson().getIdentityCard().getFio();
            userPhone = userPost.getPerson().getContactData().getPhoneWork();

        } else {
            userName = context.getFio();
        }
        String formOrgUnit_G = student.getEducationOrgUnit().getFormativeOrgUnit().getGenitiveCaseTitle() != null ? student.getEducationOrgUnit().getFormativeOrgUnit().getGenitiveCaseTitle() : student.getEducationOrgUnit().getFormativeOrgUnit().getTitle()
        String formOrgUnit = student.getEducationOrgUnit().getFormativeOrgUnit().getTitle()
        String studenType = "студент"
        Boolean isAspir = false
     //---------------------
        String lineTwo = ""
        String lineThree = ""
        String lineZero = ""
        String addressID = ""
        String position = ""
        AddressBase address = person.getIdentityCard().getAddress();
        if (address != null) {
            addressID = address.titleWithFlat

            int poi1 = addressID.indexOf("(")
            if (poi1 > 0)
                addressID = addressID.substring(0, poi1 - 1) + addressID.substring(poi1 + 4)

        }
        // специальность
        String eduLevel = ""
        String qual = ""




        if (programKind.getCode().equals(EduProgramKindCodes.PROGRAMMA_ASPIRANTURY_ADYUNKTURY_)) {
            eduLevel = "направлению подготовки аспирантов"
            isAspir = true
            studenType = "аспирант"
        } else {
            if (programKind.getCode().equals(EduProgramKindCodes.PROGRAMMA_MAGISTRATURY)) {
                eduLevel = "направлению подготовки магистров"
                qual = "магистр"
            } else {
                if (programKind.getCode().equals(EduProgramKindCodes.PROGRAMMA_BAKALAVRIATA)) {
                    eduLevel = "направлению подготовки бакалавров"
                    qual = "бакалавр"
                } else {
                    if (programKind.getCode().equals(EduProgramKindCodes.PROGRAMMA_PODGOTOVKI_SPETSIALISTOV)) {
                        eduLevel = "специальности"
                        qual = "специалист"
                    }
                }
            }
        }
        String devForm = student.getEducationOrgUnit().getDevelopForm().getTitle()
        // ---
        String specNapr = ""
        String codProg = ""
        String docProg = ""
        codProg = student.getEducationOrgUnit().getEducationLevelHighSchool().getEduProgramSubject() != null ?
                student.getEducationOrgUnit().getEducationLevelHighSchool().getEduProgramSubject().getSubjectCode() : ""
        docProg = student.getEducationOrgUnit().getEducationLevelHighSchool().getEduProgramSubject() != null ?
                student.getEducationOrgUnit().getEducationLevelHighSchool().getEduProgramSubject().getTitle() : ""
        //-------------------------------сведения о воинском учете
        String rank = ""
        String office = ""
        boolean mil = false
        String vus = ""

        //       PersonMilitaryStatus militaryStatus = DataAccessServices.dao().get(PersonMilitaryStatus.class, PersonMilitaryStatus.L_PERSON,person)
        PersonMilitaryStatus militaryStatus = new DQLSelectBuilder().fromEntity(PersonMilitaryStatus.class, "pms")
                .where(eq(property("pms", PersonMilitaryStatus.person()), value(person)))
                .createStatement(this.session).uniqueResult()
        if (militaryStatus != null) {
            rank = militaryStatus.getMilitaryRank() == null ? "" : militaryStatus.getMilitaryRank().getTitle()
            // воинское звание
            office = militaryStatus.getMilitaryOffice() == null ? "" : militaryStatus.getMilitaryOffice().getTitle()
            vus = militaryStatus.getVUSNumber() == null ? "–" : militaryStatus.getVUSNumber()
        }

        // -- ПРИКАЗ -----------отчисление или поступление в университет
        // --- данные приказов на зачисление и восстановление в записи OrderData ---
        OrderData ordat = new DQLSelectBuilder().fromEntity(OrderData.class, "ord")
                .where(eq(property("ord", OrderData.student()), value(student)))
                .createStatement(this.session).uniqueResult()

        String orderNumber = ""
        String orderDate = ""
        String reason = ""
        String toCourse = ""
        String holidayFrom = ""
        String holidayTo = ""
        String statCode = student.getStatus().getCode()
        if (ordat != null) {
            switch (statCode) {
            // -- закончил с дипломом - отчислен в связи с окончанием (диплом с отличием или без)
                case "3":
                    if (ordat.getGraduateSuccessDiplomaOrderNumber() != null) {
                        orderNumber = ordat.getGraduateSuccessDiplomaOrderNumber();
                        orderDate = ordat.getGraduateSuccessDiplomaOrderDate() == null ? "" : DateFormatter.DEFAULT_DATE_FORMATTER.format(ordat.getGraduateSuccessDiplomaOrderDate());
                        //                    - ищем выписку на этот приказ  - диплом с отличием
                        MireaExcludeSuccessStuListExtract listExtr = new DQLSelectBuilder()
                                .top(1)
                                .fromEntity(MireaExcludeSuccessStuListExtract.class, "ext")
                                .where(eq(property("ext", MireaExcludeSuccessStuListExtract.entity()), value(student)))
                                .where(eq(property("ext", MireaExcludeSuccessStuListExtract.paragraph().order().number()), value(orderNumber)))
                                .where(eq(property("ext", MireaExcludeSuccessStuListExtract.paragraph().order().commitDate()), value(ordat.getExcludeOrderDate())))
                                .createStatement(session).uniqueResult();
                        if (listExtr != null) {
                            holidayFrom = listExtr.holidayFrom == null ? "" : DateFormatter.DEFAULT_DATE_FORMATTER.format(listExtr.holidayFrom)
                            holidayTo = listExtr.holidayTo == null ? "" : DateFormatter.DEFAULT_DATE_FORMATTER.format(listExtr.holidayTo)
                        }
                    } else {
                        orderNumber = ordat.getGraduateDiplomaOrderNumber() != null ? ordat.getGraduateDiplomaOrderNumber() : "";
                        orderDate = ordat.getGraduateDiplomaOrderDate() == null ? "" : DateFormatter.DEFAULT_DATE_FORMATTER.format(ordat.getGraduateDiplomaOrderDate());
                        //                    - ищем выписку на этот приказ  - диплом без отличия
                        MireaExcludeStuListExtract listExtr = new DQLSelectBuilder()
                                .top(1)
                                .fromEntity(MireaExcludeStuListExtract.class, "ext")
                                .where(eq(property("ext", MireaExcludeStuListExtract.entity()), value(student)))
                                .where(eq(property("ext", MireaExcludeStuListExtract.paragraph().order().number()), value(orderNumber)))
                                .where(eq(property("ext", MireaExcludeStuListExtract.paragraph().order().commitDate()), value(ordat.getExcludeOrderDate())))
                                .createStatement(session).uniqueResult();
                        if (listExtr != null) {
                            holidayFrom = listExtr.holidayFrom == null ? "" : DateFormatter.DEFAULT_DATE_FORMATTER.format(listExtr.holidayFrom)
                            holidayTo = listExtr.holidayTo == null ? "" : DateFormatter.DEFAULT_DATE_FORMATTER.format(listExtr.holidayTo)
                        }
                    }
                    break;
            // -- отчислен - по разным причинам 
            //          2.8 - отчисление в связи окончанием   2.4 - аспирантуры
                case "8":
                    if (ordat.getExcludeOrderNumber() != null) {
                        List<String> extCode = Arrays.asList("1.7", "1.26", "1.27", "1.1001", "1.002");
                        orderNumber = ordat.getExcludeOrderNumber();
                        orderDate = ordat.getExcludeOrderDate() == null ? "" : DateFormatter.DEFAULT_DATE_FORMATTER.format(ordat.getExcludeOrderDate());
                        // --- ищем индивидуальную выписку на этот приказ
                        ModularStudentExtract modExtr = new DQLSelectBuilder()
                                .top(1)
                                .fromEntity(ModularStudentExtract.class, "ext")
                                .where(eq(property("ext", ModularStudentExtract.entity()), value(student)))
                                .where(eq(property("ext", ModularStudentExtract.paragraph().order().number()), value(orderNumber)))
                                .where(eq(property("ext", ModularStudentExtract.paragraph().order().commitDate()), value(ordat.getExcludeOrderDate())))
                                .where(DQLExpressions.in(property("ext", ModularStudentExtract.type().code()), extCode))
                                .createStatement(session).uniqueResult();
                        if (modExtr != null)
                            reason = modExtr.reason.title
                        else // приказ списочный 2.8 или 2.4
                            reason = "в связи с окончанием"
                    }
                    break;
            // --  ищем приказы о поступлении 
                default:
                    // -- проверяем инд.приказы - зачисление, восстановление, перевод на старшие курсы
// --  коды типов приказов  -- "1.11","1.14" - зачисление * "1.15" - перевод * "1.17" и далее - восстановление
                    List<String> extCode = Arrays.asList("1.11", "1.14", "1.15", "1.17", "1.61", "1.73", "1.77", "1.81");

                    ModularStudentExtract modExtr = new DQLSelectBuilder()
                            .top(1)
                            .fromEntity(ModularStudentExtract.class, "ext")
                            .where(eq(property("ext", ModularStudentExtract.entity()), value(student)))
                            .where(DQLExpressions.in(property("ext", ModularStudentExtract.type().code()), extCode))
                            .order(property("ext", ModularStudentExtract.paragraph().order().commitDate()), OrderDirection.desc)
                            .createStatement(session).uniqueResult();
                    // были инд приказы
                    if (modExtr != null) {
                        String ordType = modExtr.getType().getCode();
                        Date comDate = modExtr.getParagraph().getOrder().getCommitDate();
                        orderNumber = modExtr.getParagraph().getOrder().getNumber();
                        orderDate = DateFormatter.DEFAULT_DATE_FORMATTER.format((Date) comDate);
                        toCourse = modExtr.getCourseNew().getTitle();
                    } else {
                        // считаем, что это зачисление через Абитуриент на 1 курс
                        toCourse = "1"
                        orderNumber = ordat != null ? ordat.getEduEnrollmentOrderNumber() : ''
                        orderDate = ordat == null ? "" : DateFormatter.DEFAULT_DATE_FORMATTER.format(ordat.getEduEnrollmentOrderDate())
                        // приказ о зачислении
                    }
                    break;
            }
        }

// ------------------
        if (statCode == "8") {
            lineZero = "уволен с работы (отчислен из образовательной организации)"
            lineTwo = "из "
            if (!("branch".equals(student.getEducationOrgUnit().getFormativeOrgUnit().getOrgUnitType().getCode())))
                lineTwo = lineTwo + "федерального государственного бюджетного образовательного учреждения высшего образования «МИРЭА — Российский технологический университет» (РТУ МИРЭА) "
            lineTwo = lineTwo + formOrgUnit_G + " по очной форме обучения по " + eduLevel + " " + codProg + " «" + docProg + "»"
            position = "с должности"
            //lineThree = "по очной форме обучения " +eduLevel+" "+codProg+" «"+docProg+"» с присвоением квалификации «" + qual+"»"
            //if (qual=="бакалавр")
            //lineThree =+ " после предоставленных ему каникул с "+holidayFrom+" по "+holidayTo
        }
        //if(statCode == "8"){
        //lineTwo = "отчислен "+StringUtils.uncapitalize(reason)+" из федерального государственного бюджетного образовательного учреждения высшего оюразования «Московский технологический университет» (МИРЭА)"
        //}
        if (statCode == "3") {
            lineZero = "отчислен в связи с завершением обучения с"
            lineTwo = "из "
            if (!("branch".equals(student.getEducationOrgUnit().getFormativeOrgUnit().getOrgUnitType().getCode())))
                lineTwo = lineTwo + "федерального государственного бюджетного образовательного учреждения высшего образования «МИРЭА — Российский технологический университет» (РТУ МИРЭА) "
            lineTwo = lineTwo + formOrgUnit_G + " по очной форме обучения по " + eduLevel + " " + codProg + " «" + docProg + "»"
            position = "с должности"
            //lineThree = "по очной форме обучения " +eduLevel+" "+codProg+" «"+docProg+"» с присвоением квалификации «" + qual+"»"
            //if (qual=="бакалавр")
            //lineThree =+ " после предоставленных ему каникул с "+holidayFrom+" по "+holidayTo
        }
        if (statCode != "3" && statCode != "8") {
            String yearStr = now.getYear().toString();
            if (!isAspir) {
                lineZero = "зачислен с 01 сентября " + yearStr + " года"
                if (!"branch".equals(student.getEducationOrgUnit().getFormativeOrgUnit().getOrgUnitType().getCode())) {
                    lineTwo = "в федеральное государственное бюджетное образовательное учреждение высшего образования «МИРЭА — Российский технологический университет» (РТУ МИРЭА) на "
                    lineTwo = lineTwo + toCourse + " курс " + formOrgUnit_G + " по очной форме обучения по " + eduLevel + " " + codProg + " «" + docProg + "»"
                } else {
                    lineTwo = "в " + student.getEducationOrgUnit().getFormativeOrgUnit().getTitle()
                    lineTwo = lineTwo + " на " + toCourse + " курс по очной форме обучения по " + eduLevel + " " + codProg + " «" + docProg + "»"
                }
                position = "на должность"
            } else {
                lineZero = "зачислен с 01 сентября " + yearStr + " года"
                lineTwo = "в аспирантуру федерального государственного бюджетного образовательного учреждения высшего образования «МИРЭА — Российский технологический университет» (РТУ МИРЭА) на " + toCourse + " курс " + formOrgUnit_G + " по очной форме обучения по " + eduLevel + " " + codProg + " «" + docProg + "»"
                position = "на должность"
                //lineThree = toCourse+" курс "+ formOrgUnit_G +" по очной форме обучения по "+ eduLevel+ " "+codProg+" «"+docProg+"»"
            }
        }
// ------------------------------- Кампус
        String addressKampus = "просп. Вернадского, д. 78, Москва, 119454"
        String telephone = "тел.: (499) 215 65 65 доб. 1140, факс: (495) 434 92 87"
        String kampus = ""
        String addressKampusFiz = ""
        String Title = "РТУ МИРЭА"
        switch (student.getEducationOrgUnit().getFormativeOrgUnit().getNominativeCaseTitle()) {
            case "Институт комплексной безопасности и специального приборостроения":
                kampus = "МГУПИ"
                break
            case "Институт экономики и права":
                kampus = "МГУПИ"
                break
            case "Институт вечернего и заочного образования":
                kampus = "МГУПИ"
                break
            case "Институт тонких химических технологий":
                kampus = "МИТХТ"
                break
            case "Колледж":
                kampus = "МГУПИ"
                break
            case "Аспирантура":
                kampus = "МИРЭА"
                break
            case "Филиал федерального государственного бюджетного образовательного учреждения высшего образования «МИРЭА — Российский технологический университет» в г. Фрязино Московской области":
                Title = student.getEducationOrgUnit().getFormativeOrgUnit().getShortTitle()
                addressKampus = "141191, Московская обл., г.Фрязино, ул.Вокзальная, д.2а"
                addressKampusFiz = "141191, Московская обл., г.Фрязино, ул.Вокзальная, д.2а"
                telephone = "тел.: (495) 465 88 97"
                break
            case "Филиал федерального государственного бюджетного образовательного учреждения высшего образования «МИРЭА — Российский технологический университет» в г. Ставрополе":
                Title = student.getEducationOrgUnit().getFormativeOrgUnit().getShortTitle()
                addressKampus = "355000, г.Ставрополь, пр-кт Кулакова, д.18"
                addressKampusFiz = "355000, г.Ставрополь, пр-кт Кулакова, д.18"
                telephone = "тел.: (8652) 94 39 81"
                break
        }
        if (kampus == "МГУПИ") {
            addressKampusFiz = "107996, г. Москва, ул. Стромынка, д. 20"
        }
        if (kampus == "МИТХТ") {
            addressKampusFiz = "119571, г. Москва, Проспект Вернадского, д. 86"
        }
        if (kampus == "МИРЭА") {
            addressKampusFiz = "119454, г. Москва, Проспект Вернадского, д. 78"
        }

//        
        String bd = person.getIdentityCard().getBirthDate() == null ? "" : (DateFormatter.DEFAULT_DATE_FORMATTER.format(person.getIdentityCard().getBirthDate())).substring(6);
        String postFio = post.getPerson().getIdentityCard().getIof()
        String postPost = post.postRelation.postBoundedWithQGandQL.title
        switch (postPost) {
            case "Начальник управления":
                postPost = "Начальник Управления мобилизационной подготовки"
                break
            case "Заместитель начальника управления":
                postPost = "Заместитель начальника Управления мобилизационной подготовки"
                break
        }
        RtfDocument document = new RtfReader().read(template)
        im.put("sprDate", sprDate)
        im.put("sprNumber", sprNumber)
        im.put("userName", userName)
        im.put("userPhone", userPhone)

        im.put("fullFio", person.getIdentityCard().getFullFio())
        im.put("birthYear", bd)
        im.put("regAdres", addressID)
        im.put("vus", vus)
//-----------------------------------сведения о воинском учете        
        im.put("rank", rank)
        im.put("militaryOffice", office)
        im.put("post", postPost)
        im.put("postName", postFio)
//------------------ поступление или в университет

        im.put("orderDate", orderDate)
        im.put("orderNumber", orderNumber)
        /*
                         .put("orderReason", reason)
                         .put ("toCourse", toCourse)
                         .put("holidayFrom", holidayFrom)
                        .put("holidayTo", holidayTo)
        */
                .put("lineTwo", lineTwo)
                .put("lineThree", lineThree)
                .put("lineZero", lineZero)
                .put("position", position)
                .put("Title", Title)
                .put("address", addressKampus)
                .put("addressKampusFiz", addressKampusFiz)
                .put("telephone", telephone)
                .put("studentType", studenType)


//  ------------------------        

        im.modify(document)
        tm.modify(document)

        return [document: RtfUtil.toByteArray(document),
                fileName: "Форма-Пр9_${person.fullFio}.rtf",
                rtf     : document]
    }

}