package unimirea_code.scripts.students

import org.apache.commons.lang.StringUtils
import org.apache.commons.lang.text.StrBuilder
import org.hibernate.Session
import org.tandemframework.core.view.formatter.DateFormatter
import org.tandemframework.hibsupport.DataAccessServices
import org.tandemframework.rtf.document.RtfDocument
import org.tandemframework.rtf.io.RtfReader
import org.tandemframework.rtf.modifiers.RtfInjectModifier
import org.tandemframework.rtf.util.RtfUtil
import org.tandemframework.shared.commonbase.base.bo.Declinable.logic.GrammaCase
import org.tandemframework.shared.organization.base.entity.OrgUnit
import org.tandemframework.shared.organization.base.entity.TopOrgUnit
import org.tandemframework.shared.person.base.bo.Person.PersonManager
import org.tandemframework.shared.person.base.entity.IdentityCard
import ru.tandemservice.uni.entity.catalog.EduProgramKind
import ru.tandemservice.uni.entity.catalog.EducationLevelsHighSchool
import ru.tandemservice.uni.entity.orgstruct.AcademyData
import ru.tandemservice.uni.util.formatters.PersonIofFormatter
import ru.tandemservice.uniclient.unimirea_code.base.bo.MilitaryDocument.logic.ModelAddMd4

// import org.tandemframework.shared.nsiclient.entity.NsiEntity;
import ru.tandemservice.uni.util.rtf.UniRtfUtil
import ru.tandemservice.uniclient.unimirea_code.clientUtils.UnimireaProjectUtils;

import java.text.SimpleDateFormat

/* $Id:$ */

return new MilitaryP32P2Print(
        session: session,
        template: template,
        model: object
).print();

class MilitaryP32P2Print {
    Session session
    byte[] template
    ModelAddMd4 model

    RtfInjectModifier injectModifier = new RtfInjectModifier()

    def print() {
        RtfDocument document = new RtfReader().read(template)

        TopOrgUnit academy = TopOrgUnit.getInstance();
        // TODO Method removed in 2.20.6 AcademyData academyData = AcademyData.getInstance();
        AcademyData academyData = (AcademyData) DataAccessServices.dao().getList(AcademyData.class, new String[0]).get(0)

        String rectorAltStr = "";
        if (academy.getHead() != null)
            rectorAltStr = (PersonIofFormatter.INSTANCE.format((IdentityCard) academy.getHead().getEmployee().getPerson().getIdentityCard()));

        IdentityCard identityCard = model.getStudent().getPerson().getIdentityCard();
        OrgUnit formativeOrgUnit = model.getStudent().getEducationOrgUnit().getFormativeOrgUnit();
        EducationLevelsHighSchool educationLevelHS = model.getStudent().getEducationOrgUnit().getEducationLevelHighSchool();
        EduProgramKind programKind = educationLevelHS.getEduProgramSubject().getEduProgramKind();
        boolean male = identityCard.getSex().isMale();
        Calendar c = Calendar.getInstance();
        c.setTime(model.getFormingDate());
//        String name_D = PersonManager.instance().declinationDao().getCalculatedFIODeclination(extract.entity.getPerson().getIdentityCard(), InflectorVariantCodes.RU_DATIVE)
        String address = "просп. Вернадского, д. 78, Москва, 119454"
        String telephone = "тел.: (499) 215 65 65 доб. 1140, факс: (495) 434 92 87"
        String kampus = "РТУ МИРЭА"
        String Title = formativeOrgUnit.getNominativeCaseTitle()
        switch (Title) {
            case "филиал федерального государственного бюджетного образовательного учреждения высшего образования «Московский технологический университет» в г. Фрязино Московской области":
                kampus = formativeOrgUnit.getShortTitle()
                address = "141191, Московская обл., г.Фрязино, ул.Вокзальная, д.2а"
                telephone = "тел.: (495) 465 88 97"
                break
            case "филиал федерального государственного бюджетного образовательного учреждения высшего образования «Московский технологический университет» в г. Ставрополе":
                kampus = formativeOrgUnit.getShortTitle()
                address = "355000, г.Ставрополь, пр-кт Кулакова, д.18"
                telephone = "тел.: (8652) 94 39 81"
                break
        }

        String lastName = PersonManager.instance().declinationDao().getDeclinationLastName(identityCard.getLastName(), GrammaCase.DATIVE, male);
        String firstName = PersonManager.instance().declinationDao().getDeclinationFirstName(identityCard.getFirstName(), GrammaCase.DATIVE, male);
        String middleName = PersonManager.instance().declinationDao().getDeclinationMiddleName(identityCard.getMiddleName(), GrammaCase.DATIVE, male);
        String name_D = lastName + " " + firstName + " " + middleName
        Date birthDate = model.getStudent().getPerson().getIdentityCard().getBirthDate();
        String yearBirth = birthDate == null ? "____" : new SimpleDateFormat("yyyy").format(birthDate)//
        String orderNumber = model.getEnrollmentOrderNumber() == null ? "_______" : model.getEnrollmentOrderNumber()
        String orderDate = model.getEnrollmentOrderDate() == null ? "__________" : new SimpleDateFormat("dd.MM.yyyy").format(model.getEnrollmentOrderDate())
        String sprDate = model.getFormingDate() == null ? "__________" : DateFormatter.DEFAULT_DATE_FORMATTER.format(model.getFormingDate())
        String sprNumber = model.getDocNumber();
        String entranceYear = model.getEntranceYear() == null ? "____" : Integer.toString(model.getEntranceYear())
        String educationLevelStage = ""
        if (programKind.isProgramSecondaryProf() && educationLevelHS.getInDepthStudy() != null) {
            educationLevelStage = model.getEducationLevelStage() == null ? "" : model.getEducationLevelStage()
            int poiScob = educationLevelStage.indexOf("образование", 1);
            educationLevelStage = poiScob > 0 ? educationLevelStage.substring(0, poiScob) : educationLevelStage
            educationLevelStage = StringUtils.uncapitalize(educationLevelStage)
        }
        String levelTypeStr = "";
        String endNapr = "ему"
        if (programKind.isProgramMasterDegree() || programKind.isProgramBachelorDegree())
            levelTypeStr = "по направлению подготовки";
        else {
            levelTypeStr = "по специальности";
            endNapr = "ей"
        }

        SimpleDateFormat DD_DATE = new SimpleDateFormat("dd");
        SimpleDateFormat YY_DATE = new SimpleDateFormat("yyyy");
        String formOrgUnit = formativeOrgUnit.getPrepositionalCaseTitle() != null ? StringUtils.uncapitalize(formativeOrgUnit.getPrepositionalCaseTitle()) :
                StringUtils.uncapitalize(formativeOrgUnit.getPrintTitle())
        String uniTitle = StringUtils.uncapitalize(academy.getTitle())
        String programStartYear = model.getProgramStartYear() != null ? String.valueOf(model.getProgramStartYear()) : "______"
        String programEndMonth = model.getMonth() != null ? " " + model.getMonth().getTitle() : "____________________"
        String programEndYear = model.getProgramEndYear() != null ? String.valueOf(model.getProgramEndYear()) : "______"
        String managerMilitaryFIO = model.getManagerMilitaryDepartment() != null ? model.getManagerMilitaryDepartment() : ""
        String bossFirstName = model.getEmployeePost().person.identityCard.firstName
        String bossFI = bossFirstName == null ? "" : bossFirstName.substring(0, 1) + "."
        bossFI = bossFI + (model.getEmployeePost().person.identityCard.lastName == null ? " " : model.getEmployeePost().person.identityCard.lastName)

        final String lastNameSign = model.getEmployeePost().getEmployee().getPerson().getIdentityCard().getLastName();
        final String firstNameSign = model.getEmployeePost().getEmployee().getPerson().getIdentityCard().getFirstName();
        final String middleNameSign = model.getEmployeePost().getEmployee().getPerson().getIdentityCard().getMiddleName();

        final StrBuilder strSign = new StrBuilder(lastNameSign.length() + 5);
        if (StringUtils.isNotEmpty(firstNameSign)) {
            strSign.append(Character.toTitleCase(firstNameSign.charAt(0))).append('.');
        }
        if (StringUtils.isNotEmpty(middleNameSign)) {
            strSign.append(Character.toTitleCase(middleNameSign.charAt(0))).append('.');
        }
        strSign.append(' ').append(lastNameSign);

        injectModifier
                .put("kampus", kampus)
                .put("Title", Title)
                .put("address", address)
                .put("telephone", telephone)
                .put("name_D", name_D)
                .put("birthDate", yearBirth)
                .put("gender", male ? "он" : "она")
                .put("sprDate", sprDate)
                .put("sprNumber", sprNumber)
                .put("citizen", male ? "гражданину" : "гражданке")
                .put("entranceYear", entranceYear)
                .put("attempted", male ? "поступил" : "поступила")
                .put("enrollmentOrderNumber", orderNumber)
                .put("enrollmentOrderDate", orderDate)
                .put("educationLevelStage", educationLevelStage)
                .put("levelType", levelTypeStr)
                .put("endNapr", endNapr)
                .put("course", model.getCourse().getTitle())
                .put("developForm_G", model.getStudent().getEducationOrgUnit().getDevelopForm().getGenCaseTitle())
                .put("formativeOrgUnit_P", formOrgUnit)
                .put("unTitleAtTimeAdmission", uniTitle)
                .put("levelHighSchool", educationLevelHS.eduProgramSubject.titleWithCode)
                .put("certificateSeria", "серия " + academyData.getCertificateSeria())
                .put("certificateNumber", "№ " + academyData.getCertificateNumber())
                .put("certificateRegNumber", "№ " + academyData.getCertificateRegNumber())
                .put("certificateDate", DateFormatter.DEFAULT_DATE_FORMATTER.format(academyData.getCertificateDate()))
                .put("certificateExpiriationDate", DateFormatter.DEFAULT_DATE_FORMATTER.format(academyData.getCertificateExpiriationDate()))
                .put("certificationAgency", academyData.getCertificationAgency())

                .put("plannedEndYear", String.valueOf(model.getYearOut()))
                .put("militaryOffice", model.getMilitaryOfficeTitle())
                .put("concluded", male ? "Заключил" : "Заключила")
                .put("initiated", male ? "приступил" : "приступила")
                .put("rectorAlt", rectorAltStr)
                .put("miliOne", "Заключил контракт и приступил к обучению по программе подготовки ______________ запаса с "
                        + programStartYear + " г. Окончание обучения" + programEndMonth + " " + programEndYear + " г.")
                .put("miliTwo", "Аттестационный материал оформляет ОВК ${model.getMilitaryOfficeTitle()}")
                .put("managerMilitaryFIO", model.isTrainingOfficersActive() ? "А. Каргопольцев" : "")
                .put("bossFI", bossFI)

                .put("postSign", model.getEmployeePost().getPostRelation().getPostBoundedWithQGandQL().getTitle())
                .put("fioSign", strSign.toString())
        
        // QR Code 
        String baseUrl = "https://www.mirea.ru/recruits/"
        // NsiEntity nsiEntity = DataAccessServices.dao().get(NsiEntity.class, NsiEntity.P_ENTITY_ID, model.getStudent().getPerson().getId())
        // String qrCodeText = baseUrl + nsiEntity.getGuid()
        String qrCodeText = baseUrl + model?.student.person.guid
        injectModifier.put("qrCode",  UniRtfUtil.getQRCode(qrCodeText, 1))

        injectModifier.modify(document)

        return [document: RtfUtil.toByteArray(document),
                fileName: "Справка в военкомат (П32П2) ${model.getStudent().fullFio}.rtf",
                rtf     : document]
    }
}