package unimirea_code.scripts.students

import org.apache.commons.lang.StringUtils
import org.hibernate.Session
import org.tandemframework.core.entity.OrderDirection
import org.tandemframework.core.i18n.russian.RussianDateFormatUtils
import org.tandemframework.core.view.formatter.DateFormatter
import org.tandemframework.hibsupport.dql.DQLExpressions
import org.tandemframework.hibsupport.dql.DQLSelectBuilder
import org.tandemframework.rtf.document.RtfDocument
import org.tandemframework.rtf.io.RtfReader
import org.tandemframework.rtf.modifiers.RtfInjectModifier
import org.tandemframework.rtf.modifiers.RtfTableModifier
import org.tandemframework.rtf.util.RtfUtil
import org.tandemframework.shared.fias.base.entity.AddressBase
import org.tandemframework.shared.fias.base.entity.AddressDetailed
import org.tandemframework.shared.fias.base.entity.AddressRu
import org.tandemframework.shared.person.base.entity.Person
import org.tandemframework.shared.person.base.entity.PersonForeignLanguage
import org.tandemframework.shared.person.base.entity.PersonMilitaryStatus
import org.tandemframework.shared.person.base.entity.PersonNextOfKin
import ru.tandemservice.movestudent.entity.*
import ru.tandemservice.uni.entity.base.OrderData
import ru.tandemservice.uni.entity.base.Student
import ru.tandemservice.uniclient.unimirea_code.entity.MilitaryDocument
import ru.tandemservice.unienr14.order.entity.EnrEnrollmentExtract
import ru.tandemservice.unienr14.order.entity.EnrEnrollmentMinisteryExtract

import java.text.SimpleDateFormat

import static org.tandemframework.hibsupport.dql.DQLExpressions.*

/* $Id:$ */

return new FormT2Print(                           // стандартные входные параметры скрипта
        session: session,                                         // сессия
        template: template,                                       // шаблон
        student: student,
        executorFIO: executorFIO,
        executorPost: executorPost
).print()

class FormT2Print {
    Session session
    byte[] template
    Student student
    String executorFIO
    String executorPost

    def im = new RtfInjectModifier()
    def tm = new RtfTableModifier()

    def print() {
        //студент
        Person person = student.getPerson();
        String formativeOrgUnit = student.getEducationOrgUnit().getFormativeOrgUnit() == null ? "" : student.getEducationOrgUnit().getFormativeOrgUnit().getNominativeCaseTitle();
        if (formativeOrgUnit.contains("илиал"))
            formativeOrgUnit = student.getEducationOrgUnit().getFormativeOrgUnit() == null ? "" : student.getEducationOrgUnit().getFormativeOrgUnit().getShortTitle();
        //структурное подразделение
        String formOrgUnit = formativeOrgUnit
        //      List<PersonNextOfKin> personNextOfKinList = DataAccessServices.dao().getList(PersonNextOfKin.class, PersonNextOfKin.L_PERSON, person);  // родственники
        List<PersonNextOfKin> personNextOfKinList = new DQLSelectBuilder().fromEntity(PersonNextOfKin.class, "kin")
                .where(eq(property("kin", PersonNextOfKin.person()), value(person)))
                .createStatement(this.session).list();

        String dateT2 = DateFormatter.DEFAULT_DATE_FORMATTER.format(new Date())
        String fioMother = ''
        String fioFather = ''
        String bdMother = ''
        String bdFather = ''
        String yearMother = ''
        String yearFather = ''
        String relationDegree = ''
        String contactMotherTel = ''
        String contactFatherTel = ''
        String regPhone = ""
        String factPhone = ""
        //---------------------
        String indexID = ""
        String indexFact = ""
        String addressNoInd = ""
        String addressFactNoInd = ""

        String addressID = ""
        String addressFact = ""
        AddressBase address = person.getIdentityCard().getAddress();
        AddressBase addressF = person.getAddress();
        String xxx = "нет"
        if (address != null) {
            addressID = address.titleWithFlat
            addressNoInd = addressID
//---------------адрес прописки- ищем индекс
            AddressDetailed addressDetailed = address instanceof AddressDetailed ? address : null
            if (addressDetailed != null) {
                AddressRu addressRu = addressDetailed instanceof AddressRu ? addressDetailed : null
                if (addressRu != null) {
                    indexID = addressRu.inheritedPostCode
                    if (indexID != null) {
                        if (addressID.contains(indexID)) {
                            addressNoInd = addressID.substring(8);
                            int poi1 = addressNoInd.indexOf("(")
                            if (poi1 > 0)
                                addressNoInd = addressNoInd.substring(0, poi1 - 1) + addressNoInd.substring(poi1 + 4)
                        }
                    }
                }
            }
            if (indexID == null || StringUtils.isEmpty(indexID)) {
                if (Character.isDigit(addressNoInd.charAt(0))) {          // 1 символ - цифра - есть индекс
                    addressNoInd = addressNoInd.substring(8)
                    indexID = addressNoInd.substring(0, 6)
                }
                indexID = ""
            }
        }
        String lll = "нет"

        if (addressF != null) {
            addressFact = addressF.titleWithFlat
            addressFactNoInd = addressFact
            if (!addressFact.equals(addressID)) {

                //-------------------фактический адрес
                AddressDetailed addressDetailedFact = addressF instanceof AddressDetailed ? addressF : null
                if (addressDetailedFact != null) {
                    AddressRu addressRuFact = addressDetailedFact instanceof AddressRu ? addressDetailedFact : null
                    if (addressRuFact != null) {
                        indexFact = addressRuFact.inheritedPostCode
                        lll = indexFact
                        if (indexFact != null) {
                            if (addressFact.contains(indexFact)) {
                                addressFactNoInd = addressFactNoInd.substring(8);
                                int poi2 = addressFactNoInd.indexOf("(")
                                if (poi2 > 0)
                                    addressFactNoInd = addressFactNoInd.substring(0, poi2 - 1) + addressFactNoInd.substring(poi2 + 4)
                            }
                        }
                    }
                }
                if (indexFact == null || StringUtils.isEmpty(indexFact)) {
                    if (Character.isDigit(addressFactNoInd.charAt(0))) {
                        indexFact = addressFact.substring(0, 6)
                        addressFactNoInd = addressFactNoInd.substring(8)
                    } else {
                        indexFact = ""
                    }
                }
            }
            if (addressFact.equals(addressID)) {
                addressFactNoInd = ""
                indexFact = ""
            }
        }
//-----------------------паспорт
        String regData = ""
        String whereID = person.getIdentityCard().getIssuancePlace() != null ? person.getIdentityCard().getIssuancePlace() : ''
        String pasportType = person.getIdentityCard() != null ? person.getIdentityCard().getShortTitle() : ""
        String seriaID = person.getIdentityCard() != null ? person.getIdentityCard().seria : ''
        String numberID = person.getIdentityCard().number != null ? person.getIdentityCard().number : ''
        String dataID = person.getIdentityCard().getIssuanceDate() != null ? RussianDateFormatUtils.MONTH_STRING_DATE_FORMAT_NO_QUOTES.format(person.getIdentityCard().getIssuanceDate()) : ''

        if (person.getIdentityCard().getIssuanceDate() != null)
            dataID = "«" + dataID.substring(0, 2) + "»" + dataID.substring(2)
        String pasportPerson = person.getIdentityCard().number != null ? person.getIdentityCard().getShortTitle() + ', выдан ' + dataID + 'г. ' + whereID : ''
        Date registrationDate = person.getIdentityCard().getRegistrationPeriodFrom()
        if (registrationDate != null) {
            regData = RussianDateFormatUtils.MONTH_STRING_DATE_FORMAT_NO_QUOTES.format(registrationDate)

            regData = "«" + regData.substring(0, 2) + "»" + regData.substring(2)
        }

        String birthDay = ""
        String grazd = ""
        String birthPlace = ""

        birthDay = person.getIdentityCard().getBirthDate() != null ? DateFormatter.DEFAULT_DATE_FORMATTER.format(person.getIdentityCard().getBirthDate()) : ''
        grazd = person.getIdentityCard().getCitizenship()?.title
        if (grazd.contains("Россия"))
            grazd = "РФ"
        birthPlace = person.getIdentityCard().birthPlace != null ? person.getIdentityCard().birthPlace : ""

// специальность

        String codProg = student.getEducationOrgUnit().getEducationLevelHighSchool().getEduProgramSubject() != null ? student.getEducationOrgUnit().getEducationLevelHighSchool().getEduProgramSubject().getSubjectCode() : ""
        String docProg = student.getEducationOrgUnit().getEducationLevelHighSchool().getEduProgramSubject() != null ? student.getEducationOrgUnit().getEducationLevelHighSchool().getEduProgramSubject().getTitle() : ""
        String orgUnit = student.getEducationOrgUnit().getFormativeOrgUnit().getShortTitle();

        for (int i = 0; i < personNextOfKinList.size(); i++) {
            PersonNextOfKin relative = personNextOfKinList.get(i);
            relationDegree = relative.getRelationDegree() == null ? null : relative.getRelationDegree().getTitle();
            if (relationDegree == 'Мать') {
                fioMother = relative.getFullFio()
                bdMother = relative.getBirthDate() != null ? DateFormatter.DEFAULT_DATE_FORMATTER.format(relative.getBirthDate()) : ''
                yearMother = relative.getBirthDate() != null ? bdMother.substring(6) : ''
                contactMotherTel = relative.getPhones() != null ? relative.getPhones() : ''
            }
            if (relationDegree == 'Отец') {
                fioFather = relative.getFullFio()
                bdFather = relative.getBirthDate() != null ? DateFormatter.DEFAULT_DATE_FORMATTER.format(relative.getBirthDate()) : ''
                yearFather = relative.getBirthDate() != null ? bdFather.substring(6) : ''
                contactFatherTel = relative.getPhones() != null ? relative.getPhones() : ''
            }
        }

        //--------------факт.телефон (если пустой факт, берем мать или отца. Если все пустые - по прописке)

        factPhone = person.getContactData().getPhoneFact()
        regPhone = person.getContactData().getPhoneReg()
        if (StringUtils.isEmpty(factPhone))
            factPhone = regPhone
        if (StringUtils.isEmpty(factPhone) && !StringUtils.isEmpty(contactFatherTel))
            factPhone = contactFatherTel + "(отец)"
        if (StringUtils.isEmpty(factPhone) && !StringUtils.isEmpty(contactMotherTel))
            factPhone = contactMotherTel + "(мать)"

//------------------------------------
        String eduLevel = ""  // уровень образования
        String eduDocKind = ""  // вид документа
        String eduDoc = ""  // диплом, серия, номер
        String eduYear = ""  // год окончания
        String eduQual = ""     // квалификация
        String eduSpec = ""     // специализация
        String eduName = ""  // название организации-школы...
        if (student.getEduDocument() != null) {
            if (student.getEduDocument().getEduLevel() != null)
                eduLevel = student.getEduDocument().getEduLevel().getTitle();
            if (student.getEduDocument().getEduOrganization() != null)
                eduName = student.getEduDocument().getEduOrganization();
            if (student.getEduDocument().getSeria() != null) {
                String eduSeria = student.getEduDocument().getSeria();
                eduDoc = eduSeria
            }
            if (student.getEduDocument().getNumber() != null) {
                String eduNumber = student.getEduDocument().getNumber();
                eduDoc = eduDoc + " " + eduNumber
            }
            if (student.getEduDocument().getEduDocumentKind() != null)
                eduDocKind = student.getEduDocument().getEduDocumentKind().getShortTitle();
            if (student.getEduDocument().getEduOrganization() != null)
                eduName = student.getEduDocument().getEduOrganization();
//
            if (student.getEduDocument().getYearEnd() != null)
                eduYear = String.valueOf(student.getEduDocument().getYearEnd());
            if (student.getEduDocument().getQualification() != null)
                eduQual = student.getEduDocument().getQualification();
            if (student.getEduDocument().getEduProgramSubject() != null)
                eduQual = student.getEduDocument().getEduProgramSubject();

        }

        //----------------------------иностранный язык
        String foreignOne = ""
        String skillOne = ""
        String foreignTwo = ""
        String skillTwo = ""

//      List<PersonForeignLanguage> personForeignLanguageList =DataAccessServices.dao().getList(PersonForeignLanguage.class,PersonForeignLanguage.L_PERSON,person)
        List<PersonForeignLanguage> personForeignLanguageList = new DQLSelectBuilder().fromEntity(PersonForeignLanguage.class, "flg")
                .where(eq(property("flg", PersonForeignLanguage.person()), value(person)))
                .createStatement(this.session).list();

        for (int i = 0; i < personForeignLanguageList.size(); i++) {
            PersonForeignLanguage foreign = personForeignLanguageList.get(i);
            if (i == 0) {
                foreignOne = foreign.getLanguage() == null ? "" : foreign.getLanguage().getTitle();
                skillOne = foreign.getSkill() == null ? "" : foreign.getSkill().getTitle();
            }
            if (i == 1) {
                foreignTwo = foreign.getLanguage() == null ? "" : foreign.getLanguage().getTitle();
                skillTwo = foreign.getSkill() == null ? "" : foreign.getSkill().getTitle();
            }
        }

        //-------------------------------сведения о воинском учете
        String miliAttach = ""
        String category = ""
        String rank = ""
        String vusNumber = ""
        String ability = ""
        String miliService = ""
        String office = ""
        String crewNumber = ""
        String special = ""
        String miliRegData = ""
        String miliSeria = ""
        String miliNumber = ""
        String attachSeria = ""
        String attachNumber = ""
        boolean mil = false

        //       PersonMilitaryStatus militaryStatus = DataAccessServices.dao().get(PersonMilitaryStatus.class, PersonMilitaryStatus.L_PERSON,person)
        PersonMilitaryStatus militaryStatus = new DQLSelectBuilder().fromEntity(PersonMilitaryStatus.class, "pms")
                .where(eq(property("pms", PersonMilitaryStatus.person()), value(person)))
                .createStatement(this.session).uniqueResult()
        if (militaryStatus != null) {
            attachSeria = militaryStatus.getAttachedSeria()
            attachNumber = militaryStatus.getAttachedNumber()
            if (attachSeria != null && attachNumber != null) {
                miliAttach = attachSeria + " №" + attachNumber  // приписное свидетельство
                mil = true
            }

            if (!mil) {
                miliSeria = militaryStatus.getMilitarySeria()
                miliNumber = militaryStatus.getMilitaryNumber()
                if (miliSeria != null && miliNumber != null)
                    miliAttach = miliSeria + " №" + miliNumber  // приписное свидетельство
            }
            category = militaryStatus.getMilitaryRegCategory() == null ? "" : militaryStatus.getMilitaryRegCategory().getTitle()
            //категория запаса
            rank = militaryStatus.getMilitaryRank() == null ? "" : militaryStatus.getMilitaryRank().getTitle()
            // воинское звание
            miliRegData = militaryStatus.getMilitaryRegData() == null ? "" : militaryStatus.getMilitaryRegData().getTitle()
            vusNumber = militaryStatus.getVUSNumber() == null ? "" : militaryStatus.getVUSNumber()
            //
            ability = militaryStatus.getMilitaryAbilityStatus() == null ? "" : militaryStatus.getMilitaryAbilityStatus().getTitle()
            miliService = militaryStatus.getMilitaryService() == null ? "" : militaryStatus.getMilitaryService()
            office = militaryStatus.getMilitaryOffice() == null ? "" : militaryStatus.getMilitaryOffice().getTitle()
            crewNumber = militaryStatus.getCrewNumber() == null ? "" : militaryStatus.getCrewNumber()
            special = militaryStatus.getMilitarySpecialRegistration() == null ? "" : militaryStatus.getMilitarySpecialRegistration().getTitle()
        }

        // новое
        // =============================
        //String finishYear = student.getFinishYear() != null ? String.valueOf(student.getFinishYear()) : ""
        // =============================
        Calendar calendar = Calendar.getInstance()
        // Продолжительность программы обучения
        // число лет программы
        // int years = student.getDevelopPeriodAuto().getEduProgramDuration().getNumberOfYears()
        int years = 1
        // число месяцев программы
        // int months = student.getDevelopPeriodAuto().getEduProgramDuration().getNumberOfMonths()
        int months = 1
        calendar.setTime(new Date())
        // текущий месяц
        int nowMonth = calendar.get(Calendar.MONTH) + 1
        // текущий курс студента
        int courseInt = Integer.valueOf(student.getCourse().getTitle())
        // Сколько отучился
        // Число полных лет отучился
        int yearLast = courseInt - 1
        // Число месяцев отучился
        int monthLast = (nowMonth >= 9 && nowMonth <= 12) ? (nowMonth - 9) : (4 + nowMonth - 1)
        // Продолжительность программы в месяцах
        int monthsAllProg = years * 12 + months
        // Продолжительность пройденной программы  в месяцах
        int monthsAllStudy = yearLast * 12 + monthLast
        // Осталось  обучения в месяцах
        int monthsAllRest = monthsAllProg - monthsAllStudy
        // Лет
        int difYear1 = monthsAllRest / 12
        // Месяцев
        int finMonth = monthsAllRest % 12
        // Год окончания
        int finishYearInt = calendar.get(Calendar.YEAR) + difYear1
        if (finMonth + nowMonth > 12)
            finishYearInt = finishYearInt + 1

        String finishYear = finishYearInt.toString()

        //String finishYear = student.getFinishYear() != null ? String.valueOf(student.getFinishYear()) : student.getPlannedGraduateYear()

        //------------------------поступление в университет и перевод с курса на курс - таблица TTT
        def studTrans = new ArrayList<String[]>()

        //       OrderData orderData = DataAccessServices.dao().get(OrderData.class, OrderData.L_STUDENT, student)
        OrderData orderData = new DQLSelectBuilder().fromEntity(OrderData.class, "ord")
                .where(eq(property("ord", OrderData.student()), value(student)))
                .createStatement(this.session).uniqueResult()
        // --- данные приказов на зачисление и восстановление в записи OrderData ---
        String word = " зачислен на "
        String toCourse = "1"
        String orderNumber = ""
        String orderDate = ""
        String formOrg = formativeOrgUnit
        // -- проверяем инд.приказы - зачисление, восстановление, перевод на старшие курсы
// --  коды типов приказов  -- "1.11","1.14" - зачисление * "1.15" - перевод * "1.17" и далее - восстановление
        List<String> extCode = Arrays.asList("1.11", "1.14", "1.15", "1.17", "1.61", "1.73", "1.77", "1.81");

        CommonStuExtract comExtr = new DQLSelectBuilder()
                .top(1)
                .fromEntity(CommonStuExtract.class, "ext")
                .where(eq(property("ext", CommonStuExtract.entity()), value(student)))
                .where(DQLExpressions.in(property("ext", CommonStuExtract.type().code()), extCode))
                .order(property("ext", CommonStuExtract.paragraph().order().commitDate()), OrderDirection.desc)
                .createStatement(this.session).uniqueResult();
        // были инд приказы
        if (comExtr != null) {
            String ordType = comExtr.getType().getCode();
            toCourse = comExtr.getCourseNew().getTitle();
            Date comDate = comExtr.getParagraph().getOrder().getCommitDate();
            orderNumber = comExtr.getParagraph().getOrder().getNumber();
            orderDate = DateFormatter.DEFAULT_DATE_FORMATTER.format((Date) comDate);
            if (ordType == "1.15")
                word = " переведен на ";
            else if (extCode.indexOf(ordType) > 2)    //третий, но от нуля
                word = " восстановлен на ";
            formOrgUnit = comExtr.getEducationOrgUnitNew().getFormativeOrgUnit().getTitle()
        } else {
            // считаем, что это зачисление через Абитуриент на 1 курс
            EnrEnrollmentExtract enrExtract = new DQLSelectBuilder()
                    .top(1)
                    .fromEntity(EnrEnrollmentExtract.class, "ex")
                    .where(eq(property("ex", EnrEnrollmentExtract.student()), value(student)))
                    .where(isNotNull(property("ex", EnrEnrollmentExtract.paragraph().order().commitDate())))
                    .order(property("ex", EnrEnrollmentExtract.paragraph().order().commitDate()), OrderDirection.asc)
                    .createStatement(this.session).uniqueResult();
            if (enrExtract != null) {
                formOrgUnit = enrExtract.getParagraph().getFormativeOrgUnit().getTitle();
                orderNumber = enrExtract.getParagraph().getOrder().getNumber();
                orderDate = DateFormatter.DEFAULT_DATE_FORMATTER.format(enrExtract.getParagraph().getOrder().getCommitDate());
            } else {
                EnrEnrollmentMinisteryExtract enrMinExtract = new DQLSelectBuilder()
                        .top(1)
                        .fromEntity(EnrEnrollmentMinisteryExtract.class, "ex")
                        .where(eq(property("ex", EnrEnrollmentMinisteryExtract.student()), value(student)))
                        .where(isNotNull(property("ex", EnrEnrollmentMinisteryExtract.paragraph().order().commitDate())))
                        .order(property("ex", EnrEnrollmentMinisteryExtract.paragraph().order().commitDate()), OrderDirection.asc)
                        .createStatement(this.session).uniqueResult();
                if (enrMinExtract != null) {
                    formOrgUnit = enrMinExtract.getParagraph().getFormativeOrgUnit().getTitle();
                    orderNumber = enrMinExtract.getParagraph().getNumber();
                    orderDate = DateFormatter.DEFAULT_DATE_FORMATTER.format(enrMinExtract.getParagraph().getOrder().getCommitDate());
                }
            }
        }
        if (orderDate == null) {
            orderNumber = orderData != null ? orderData.getEduEnrollmentOrderNumber() : ''//
            orderDate = orderData == null ? "" : DateFormatter.DEFAULT_DATE_FORMATTER.format(orderData.getEduEnrollmentOrderDate())
            // приказ о зачислении
        }

        studTrans.add([orderDate + ' №' + orderNumber, formativeOrgUnit + word + toCourse + " курс"] as String[]);
        // ????

        // --------------------- приказы о перевод
/*
"1.3";"transferDevFormStuExtract";"О переводе на другую форму освоения"
"1.66";"transferCourseStuExtract";"О переводе с курса на следующий курс"
"1.92";"transferCourseWithChangeTerrOuStuExtract";"О переводе с курса на следующий курс со сменой территориального подразделения"
"1.60";"reEducationFGOSStuExtract";"О предоставлении повторного года обучения с переходом на ФГОС"
"1.36";"reEducationStuExtract";"О повторном обучении"

"2.1.1";"courseTransferStuListExtract";"Перевести на следующий курс"
"2.1.3";"courseTransferDebtorStuListExtract";"Перевести на следующий курс студентов, имеющих задолженности"
"2.1.2";"courseNoChangeStuListExtract";"Считать на прежнем курсе"
"2.30.1";"courseTransferExtStuListExtract";"Перевести на следующий курс"
"2.36.1";"territorialCourseTransferStuListExtract";"Перевести с курса на следующий курс (по направлениям подготовки) со сменой территориального подразделения"
"2.48.1";"courseTransferCustomStuListExtract";"Перевести на следующий курс"

*/
        // ---  все modularExtract -> extends commonExtract (commonExtract.courseNew)
        List<String> crossCodes = Arrays.asList("1.3", "1.66", "1.92", "1.60", "1.36", "2.1.1", "2.1.2", "2.1.3", "2.36.1", "2.48.1");
        List<AbstractStudentExtract> extList = new DQLSelectBuilder()
                .fromEntity(AbstractStudentExtract.class, "ex")
                .where(eq(property("ex", AbstractStudentExtract.entity()), value(student)))
                .where(DQLExpressions.in(property("ex", AbstractStudentExtract.type().code()), crossCodes))
                .where(isNotNull(property("ex", AbstractStudentExtract.paragraph().order().commitDate())))
                .order(property("ex", AbstractStudentExtract.paragraph().order().commitDate()), OrderDirection.asc)
                .createStatement(this.session).list();

        String newCourseStr;
        String ordNumber = "";
        String ordDate = ""
        Date commitDate;
        Date tranfDate;
        word = " переведен на "

        for (AbstractStudentExtract absExt : extList) {
            String extType = absExt.getType().getCode();
            AbstractStudentOrder tranOrder = absExt.getParagraph().getOrder();
            ordNumber = tranOrder.getNumber();
            commitDate = tranOrder.getCommitDate();
            ordDate = DateFormatter.DEFAULT_DATE_FORMATTER.format(commitDate)
            if ("1.".equals(extType.substring(0, 2))) { // --------------- modularExtract
                CommonStuExtract comExt = (CommonStuExtract) absExt;
                newCourseStr = comExt.courseNew.title;
                tranfDate = comExt.transferDate;
                formOrgUnit = comExt.getEducationOrgUnitNew().getFormativeOrgUnit().getTitle()
            } else {                                   // --------------- listExtract
                switch (extType) {
                    case "2.1.1":
                        CourseTransferStuListExtract transExt = (CourseTransferStuListExtract) absExt;
                        newCourseStr = transExt.courseNew.title;
                        tranfDate = transExt.transferDate;
                        break;
                    case "2.1.3":
                        CourseTransferDebtorStuListExtract transExt = (CourseTransferDebtorStuListExtract) absExt;
                        newCourseStr = transExt.courseNew.title;
                        tranfDate = transExt.transferDate;
                        break;
                    case "2.30.1":
                        CourseTransferExtStuListExtract transExt = (CourseTransferExtStuListExtract) absExt;
                        newCourseStr = transExt.courseNew.title;
                        tranfDate = transExt.transferDate;
                        break;
                    case "2.36.1":
                        TerritorialCourseTransferStuListExtract transExt = (TerritorialCourseTransferStuListExtract) absExt;
                        newCourseStr = transExt.courseNew.title;
                        tranfDate = transExt.transferDate;
                        break;
                    case "2.48.1":
                        CourseTransferCustomStuListExtract transExt = (CourseTransferCustomStuListExtract) absExt
                        newCourseStr = transExt.courseNew.title;
//                 tranfDate = transExt.transferDate;      // нет даты перевода
                        break
                }
            }
            studTrans.add([ordDate + ' №' + ordNumber, formativeOrgUnit + word + newCourseStr + " курс"] as String[]);
        }

        List<Object[]> militaryList = new DQLSelectBuilder()
                .fromEntity(MilitaryDocument.class, "md")
                .where(eq(property("md", MilitaryDocument.student()), value(student)))
                .where(DQLExpressions.in(property("md", MilitaryDocument.militaryDocumentType().code()), ["md.1", "md.2"]))
                .column(property("md", MilitaryDocument.formingDate()))
                .column(property("md", MilitaryDocument.number()))
                .column(property("md", MilitaryDocument.postfix()))
                .order(property("md", MilitaryDocument.formingDate()), OrderDirection.asc)
                .createStatement(this.session).list();

        /*Collections.sort(studTrans, new Comparator<String[]>() {
            @Override
            int compare(String[] strings1, String[] strings2) {
                return strings1[0].compareTo(strings2[0])
            }
        })*/

        def resultTable = new ArrayList<String[]>()
        for (int i = 0; i < studTrans.size(); i++) {
            String military = i < militaryList.size() ? DateFormatter.DEFAULT_DATE_FORMATTER.format((Date) militaryList.get(i)[0]) + " № " +
                    (String) militaryList.get(i)[1] + "/" + (String) militaryList.get(i)[2]
                    : ""
            resultTable.add([studTrans.get(i)[0], studTrans.get(i)[1], "", military] as String[])
        }

        String course = student.getCourse() != null ? student.getCourse().getTitle() : ""    // курс
        String group = student.getGroup() != null ? student.getGroup().getTitle() : ""
        String sex = student.person.identityCard.getSex().isMale() ? "М" : "Ж"
        String teleMob = person.getContactData().getPhoneMobile()
        String teleDefa = person.getContactData().getPhoneDefault()

        if (teleMob == null)
            teleMob = teleDefa
        if (teleMob != null && teleDefa != null && !teleMob.equals(teleDefa))
            teleMob = teleMob + ", " + teleDefa
        RtfDocument document = new RtfReader().read(template)
        im.put("group", group)
        im.put("sex", sex)
        im.put("dateT2", dateT2)
        im.put("lastName", person.getIdentityCard().lastName)
                .put("firstName", person.getIdentityCard().firstName)
                .put("middleName", person.getIdentityCard().middleName)
                .put("birthDate", birthDay)
                .put("birthPlace", birthPlace)
                .put("citizenship", grazd)
                .put("foreignOne", foreignOne)
                .put("skillOne", skillOne)
                .put("foreignTwo", foreignTwo)
                .put("skillTwo", skillTwo)
// -------------  EduDocument
        im.put("docLevel", eduLevel)
                .put("docKind", eduDocKind)
                .put("eduDoc", eduDoc)
                .put("docEndYear", eduYear)
                .put("docUnit", eduName)
                .put("eduQual", eduQual)
                .put("eduSpec", eduSpec)
                .put("docProg", docProg)
//               .put("docProg",String.valueOf(poiScob))
                .put("codProg", codProg)
                .put("orgUnit", orgUnit)

        // --------------

        String familyStatusStr = new DQLSelectBuilder().fromEntity(Person.class, "p")
                .column(property(Person.familyStatus().title().fromAlias("p")))
                .where(eq(property(Person.id().fromAlias("p")), value(person.id)))
                .createStatement(this.session).uniqueResult()

//      im.put("familyStatus", person.getFamilyStatus()?.title != null ? person.getFamilyStatus()?.title : "холост")
        im.put("familyStatus", familyStatusStr != null ? familyStatusStr : "холост")
                .put("fioFather", fioFather)
                .put("bdFather", yearFather)
                .put("fioMother", fioMother)
                .put("bdMother", yearMother)
        im.put("seria", seriaID)
                .put("number", numberID)
                .put("issuanceDate", dataID)
                .put("issuance", whereID)

        im.put("indexID", indexID)
                .put("addressRegistration", addressNoInd)
//                .put("indexFact",indexFact)
//                .put("indFact",indexFact)
                .put("indexFact", indexFact)
                .put("addressFact", addressFactNoInd)
//                .put("addressFact",addressFact)
                .put("factPhone", factPhone)
                .put("mobilePhone", teleMob)
                .put("regData", regData)
        // дата регистрации по месту жительства
//-----------------------------------сведения о воинском учете
        im.put("attach", miliAttach)
                .put("category", category)
                .put("rank", rank)
                .put("miliRegData", miliRegData)
                .put("vusNumber", vusNumber)
                .put("ability", ability)
                .put("miliService", miliService)
                .put("office", office)
                .put("crewNumber", crewNumber)
                .put("special", special)
                .put("finishYear", finishYear)
/*
//------------------ поступление в университет
               im.put("orderData",orderDate)
                 .put("orderNumber",orderNumber)
                 .put("formativeOrgUnit",formativeOrgUnit)
                 .put("course", toCourse)
//-------------------------------------------------------------------
 */
        tm.put("TTT", resultTable as String[][])

        String studentFIO = person.getFio()
        String pattern = "dd.MM.yyyy HH:mm"
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(pattern)
        String formingDate = simpleDateFormat.format(new Date())
        pattern = "dd.MM.yyyy"
        simpleDateFormat = new SimpleDateFormat(pattern)

    
        String militaryRegistrationDate = militaryStatus.getRegistrationDate() != null 
            ? simpleDateFormat.format(militaryStatus.getRegistrationDate())
            : ""


        im.put("orgUnitFooter", orgUnit)
                .put("executorPost", executorPost)
                .put("executorFIO", executorFIO)
                .put("studentFIO", studentFIO)
                .put("formingDate", formingDate)
                .put("registrationDate", militaryRegistrationDate)

        im.modify(document)
        tm.modify(document)

        return [document: RtfUtil.toByteArray(document),
                fileName: "Форма-Т2 ${person.fullFio}.rtf",
                rtf     : document]
    }
    /*       def String[][] getForeignData(List<PersonForeignLanguage> personForeignLanguageList)
       {
           String[][] foreignData = new String[personForeignLanguageList.size()][];
               for (int i = 0; i < personForeignLanguageList.size(); i++)
           {
               PersonForeignLanguage foreign =personForeignLanguageList .get(i);

               String foreignLanguage = foreign.getLanguage() == null ? "" : foreign.getLanguage().getTitle();
               String foreignSkill = foreign.getSkill() == null ? "" : foreign.getSkill().getTitle();
               StringBuilder builder = new StringBuilder();
               builder.append(foreignSkill);
               foreignData
               foreignData[i] = [foreignLanguage == null ? "" : foreignLanguage,builder.toString()];

           }
                   return  foreignData;
       }
   */
}